/****************************************************************
	GET/SET Data Functions
	COURSE/TRAINEE CLASSES
*****************************************************************/
var traineeDataModelArray = { 
		"username": {
			"2004": "cmi.learner_id",
			"1.2": "cmi.core.student_id"
		},
		"full_name": {
			"2004": "cmi.learner_name",
			"1.2": "cmi.core.student_name"
		},
		"lpv": {
			"2004": "cmi.location",
			"1.2": "cmi.core.lesson_location"
		},
	
		"company": {
			"2004": "company",
			"1.2": "company"
		},

		"quiz_score": {
			"2004": "cmi.objectives.n.score.raw",
			"1.2": "cmi.objectives.n.score.raw"
		},
		"status": {
			"2004": "cmi.completion_status",
			"1.2": "cmi.core.lesson_status"
		},
		"exit": {
			"2004": "cmi.exit",
			"1.2": "cmi.core.exit"
		},
		"success": {
			"2004": "cmi.success_status",
			"1.2": ""
		},
		"score.min": {
			"2004": "cmi.score.min",
			"1.2": "cmi.core.score.min"
		},
		"score.max": {
			"2004": "cmi.score.max",
			"1.2": "cmi.core.score.max"
		},
		"score.raw": {
			"2004": "cmi.score.raw",
			"1.2": "cmi.core.score.raw"
		},
		"cert_date": {
			"2004": "cmi.objectives.0.description",
			"1.2": "cmi.student_preference.language"
		}		
}

function initialiseTraineeData() {
	console.log("Tracking: "+course.tracking);
	/*** IF Tracking = YOW then Load the Data From the DB with AJAX: ***/
	if (getQueryVariable("cbtusername") == "demo_user"){
		DBValues = {
			"username": "demo_user",
			"found": "true",
			"full_name": "Demo User",
			"company": "YOW Canada Inc.",
			"lpv": "",
			"quiz_thresh": "75",
			"status": "2",
			"admin_email": "info@yowcanada.com",
			"forced_language": "",
			"QuizArray": [
				{"QuizScore": "-1",
					"QuizAttempts": "0"},
				{"QuizScore": "-1",
					"QuizAttempts": "0"},
				{"QuizScore": "-1",
					"QuizAttempts": "0"},
				{"QuizScore": "-1",
					"QuizAttempts": "0"},
				{"QuizScore": "-1",
					"QuizAttempts": "0"},
				{"QuizScore": "-1",
					"QuizAttempts": "0"},
				{"QuizScore": "-1",
					"QuizAttempts": "0"},
				{"QuizScore": "-1",
					"QuizAttempts": "0"},
				{"QuizScore": "-1",
					"QuizAttempts": "0"}
			]			
		}
	}
	else if (course.tracking == "DB")
	{
		var xhttp;  

		if (window.XMLHttpRequest)
		{/*** code for IE7+, Firefox, Chrome, Opera, Safari ***/
			xhttp=new XMLHttpRequest();
		}
		else
		{/*** code for IE6, IE5 ***/
			xhttp=new ActiveXObject("Microsoft.XMLHTTP");
		}

		xhttp.onreadystatechange=function()
		{
			/*** Append the Page Results to the Document: ***/
			if (xhttp.readyState==4 && xhttp.status==200)
			{
				var returnString = xhttp.responseText;
				
				console.log("Load Trainee Data:"+returnString);
				
				DBValues = eval ("(" + returnString + ")");
				
				initialFound = DBValues["found"];
				if(initialFound == undefined) {
					initialFound = false;
				}
			}
		}
		
		var parameters="cbtusername="+ getQueryVariable("cbtusername");
		xhttp.open("POST","../course_data/getTraineeData.asp",false);
		xhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded")
		xhttp.send(parameters);	
	}
	else if(course.tracking == "2004")
	{
		/*** CALL SCORM 2004 API INITIALIZE: ***/
		initialFound = doInitialize();
		if(doGetLastError() == "103") {
			initialFound = true;
		}
	}
	else if(course.tracking == "1.2") 
	{
		console.log("initialising scorm 1.2");
		/*** Call SCORM 1.2 API INITIALIZE: ***/
		initialFound = doLMSInitialize();
		if(doLMSGetLastError() == "101") {
			initialFound = true;
		}
	}	
}

/*** POPULATE A VARIABLE USING THE keyName to get the Proper DB/LMS storage call: ***/
function getDataValue(keyName)
{
	console.log(".. Get Data: "+keyName+" ..");
	
	try
	{
		
		/*** GET THE TRACKING TYPE: ***/
		var tracking = course.tracking;

		if(tracking == "DB")
		{
			/*** CALL THE GET THE DATA FROM THE DATA ARRAY CREATED BY THE ASP DB CALL: ***/
			return DBValues[keyName];
		}
		else
		{
			if(keyName=="company") {
				return course.companyName;
			} else if( keyName == "expiry_cycle") {
				return course.expiryCycle;
			} else if(keyName == "quiz_thresh") {
				return course.quizThresh;
			} else if(keyName == "admin_email") {
				return course.adminEmail;
			} else if(keyName == "adminID") {
				return course.scorm_id;
			} else if(keyName == "forced_language") {
				return course.scorm_forced_lang;
			} else if(keyName == "disable_autonav ") {
				return course.scorm_disable_autonav;
			} else if(keyName == "course_version") {
				return course.scorm_course_version;
			} else if(keyName == "status") {
				var status = 1;
				var lmsStatus;
				if(tracking == "2004")
				{
					/*** CALL THE SCORM 2004 GET DATA USING THE CORRECT DATA MODEL NAME: ***/
					lmsStatus = doGetValue(traineeDataModelArray[keyName][tracking]);
				}
				else if(tracking == "1.2")
				{
					/*** CALL THE SCORM 1.2 GET DATA USING THE CORRECT DATA MODEL NAME: ***/
					lmsStatus = doLMSGetValue(traineeDataModelArray[keyName][tracking]);
				}
				
				console.log("LMS Status:" + lmsStatus);
				
				if (lmsStatus == "passed" || lmsStatus == "complete" || lmsStatus == "completed"){
					status = 4;
					//status = 2;
				} else if (lmsStatus == "incomplete") {
					status = 2;
				}
				
				console.log("Status: " + status);
				
				return status;
			}else {
			
				if(tracking == "2004")
				{
					/*** CALL THE SCORM 2004 GET DATA USING THE CORRECT DATA MODEL NAME: ***/
					console.log("Returning: "+traineeDataModelArray[keyName][tracking]+" Value: "+doGetValue(traineeDataModelArray[keyName][tracking]));
					return doGetValue(traineeDataModelArray[keyName][tracking]);
				}
				else if(tracking == "1.2")
				{
					/*** CALL THE SCORM 1.2 GET DATA USING THE CORRECT DATA MODEL NAME: ***/
					console.log("Returning: "+traineeDataModelArray[keyName][tracking]+" Value: "+doLMSGetValue(traineeDataModelArray[keyName][tracking]));				
					return doLMSGetValue(traineeDataModelArray[keyName][tracking]);
				}
				else
				{
					console.log("Get Failed no tracking?");
					return false;
				}
			
				
			}
		}
	}
	catch (err)
	{
		/*** THE DATA COULD NOT BE LOADED: ***/
		console.log("Get Failed: "+err);
		return false;
	}
	
}

/*
TODO:
*/
/*** SAVE THE DATA: ***/
function setDataValue(dataVariable, dataValue) {

	console.log(".. Set Data: "+dataVariable+" = "+dataValue+" ..");

	try
	{
		
		/*** GET THE TRACKING TYPE: ***/
		var tracking = course.tracking;
		
		if(tracking == "DB" && getQueryVariable("cbtusername") != "demo_user")
		{
			/*** CALL THE SAVE DATA ASP: ***/
			var xhttp;  

			if (window.XMLHttpRequest)
			{/*** code for IE7+, Firefox, Chrome, Opera, Safari ***/
				xhttp=new XMLHttpRequest();
			}
			else
			{/*** code for IE6, IE5 ***/
				xhttp=new ActiveXObject("Microsoft.XMLHTTP");
			}

			xhttp.onreadystatechange=function()
			{
				/*** Append the Page Results to the Document: ***/
				if (xhttp.readyState==4 && xhttp.status==200)
				{
					var returnString = xhttp.responseText;
					/*console.log(returnString);*/
					/*** CHECK TO SEE IF THERE WAS AN ERROR RETURNED: ***/
				}
			}
			
			var parameters="cbtusername="+ user.username;
			parameters +="&dataVariable="+ dataVariable;
			parameters +="&dataValue="+ dataValue;
			xhttp.open("POST", "../course_data/setTraineeData.asp",false);
			xhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded")
			xhttp.send(parameters);				
		}
		else
		{
			if(dataVariable=="status" && dataValue == 2) {
				setDataValue("status", "incomplete");
			} else {
		
					
				if(tracking == "2004")
				{
					/*** ASSIGN THE VALUE TO THE VARIABLE ***/
					/*** COMMIT THE CHANGES ***/
					console.log("Setting LMS: "+dataVariable+" SCORM VAR: "+traineeDataModelArray[dataVariable][tracking]+" VALUE: "+dataValue);
					doSetValue(traineeDataModelArray[dataVariable][tracking], dataValue);
					doCommit();
				}
				else if(tracking == "1.2")
				{
					/*** ASSIGN THE VALUE TO THE VARIABLE ***/
					/*** COMMIT THE CHANGES ***/
					console.log("Setting LMS: "+dataVariable+" SCORM VAR: "+traineeDataModelArray[dataVariable][tracking]+" VALUE: "+dataValue);
					doLMSSetValue(traineeDataModelArray[dataVariable][tracking], dataValue);
					doLMSCommit();
				}
				else
				{
					console.log("Setting LMS Failed ");
					return false;
				}
			}
		}
	}
	catch (err)
	{
		/*** THE DATA COULD NOT BE LOADED: ***/
		console.log("Setting LMS Failed " + err);
		return false;
	}
	
}

/*** SPECIAL GET QUIZ CALL: ***/
function getQuizValue(chapterNum)
{
	console.log(".. Get QuizValue Chapter: "+chapterNum+" ..");
	
	try 
	{
		/*** GET THE TRACKING TYPE: ***/
		var tracking = course.tracking;

		if(tracking == "DB")
		{
			/*** CALL THE SAVE QUIZ ASP: ***/
			return DBValues["QuizArray"][chapterNum-1]["QuizScore"];
		}
		else
		{
			var score;
			var objectiveNum = chapterNum-1;
			
			if(tracking == "2004")
			{
				/*** CALL THE SCORM 2004 GET DATA USING THE CORRECT DATA MODEL NAME: ***/
				doSetValue("cmi.objectives."+objectiveNum+".id", "Quiz"+chapterNum);
				doCommit();
				score = doGetValue("cmi.objectives."+objectiveNum+".score.raw");
			}
			else if(tracking == "1.2")
			{
				/*** CALL THE SCORM 1.2 GET DATA USING THE CORRECT DATA MODEL NAME: ***/
				doLMSSetValue("cmi.objectives."+objectiveNum+".id", "Quiz"+chapterNum);				
				doLMSCommit();
				score = doLMSGetValue("cmi.objectives."+objectiveNum+".score.raw");
			}
			else
			{
				return false;
			}
			
			/*console.log("score "+chapterNum+": "+score);*/
			
			if (score == "" || score == undefined) {
				score = -1;
			}
			return score;
		}
	}
	catch(err) {
		/*** THE DATA COULD NOT BE LOADED ***/
		return false;
	}
}

function setQuizValue(chapterNum, score, attempts, questions)
{
	console.log(".. Set QuizValue Chap: "+chapterNum+" Score="+score+" Attempts="+attempts+" ..");
	
	try 
	{
		/*** GET THE TRACKING TYPE: ***/
		var tracking = course.tracking;

		if(tracking == "DB" && getQueryVariable("cbtusername") != "demo_user")
		{
			///*** Call Save Data Functions for QuizScore, Quiz Attempts, Quiz Questions: ***/
			//var xhttp;  
            //
			//if (window.XMLHttpRequest)
			//{/*** code for IE7+, Firefox, Chrome, Opera, Safari ***/
			//	xhttp=new XMLHttpRequest();
			//}
			//else
			//{/*** code for IE6, IE5 ***/
			//	xhttp=new ActiveXObject("Microsoft.XMLHTTP");
			//}
            //
			//xhttp.onreadystatechange=function()
			//{
			//	/*** Append the Page Results to the Document: ***/
			//	if (xhttp.readyState==4 && xhttp.status==200)
			//	{
			//		var returnString = xhttp.responseText;
			//		/*console.log(returnString);*/
			//		/*** CHECK TO SEE IF THERE WAS AN ERROR RETURNED: ***/
			//	}
			//}
			//
			//var parameters="cbtusername="+ user.username;
			//parameters +="&chapter="+ chapterNum;
			//parameters +="&score="+ score;
			//parameters +="&attempts="+ attempts;
			//parameters +="&questions="+ questions;
			//
			////xhttp.open("POST","http://www.yowcanada.com/ASP TEST/ASPFILES/COURSE_DATA/setTraineeQuizData.asp",false);
			//xhttp.open("POST","http://ibt.yowcanada.com/ASPFILES/trainee_course_data/setTraineeQuizData.asp",false);
			//xhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
			//xhttp.send(parameters);	
			
			console.log("** Saving EOC SCORE: ** - DB");
		
			var returnValues = new Array(); 
			
			var xhttp;  
		
			if (window.XMLHttpRequest)
			{/*** code for IE7+, Firefox, Chrome, Opera, Safari ***/
				xhttp=new XMLHttpRequest();
			}
			else
			{/*** code for IE6, IE5 ***/
				xhttp=new ActiveXObject("Microsoft.XMLHTTP");
			}
			
			xhttp.onreadystatechange=function()
			{
				/*** Append the Page Results to the Document: ***/
				if (xhttp.readyState==4 && xhttp.status==200)
				{
					var returnString = xhttp.responseText;
						
					console.log("Save Data:"+returnString);
						
					returnValues = eval ("(" + returnString + ")");
					
					//var tempVar = returnValues["var_name"];
					var numCorrect = returnValues["numCorrect"];
					var questionsAsked = returnValues["questionsAsked"];
										
					console.log("numCorrect: "+numCorrect);
					console.log("questionsAsked: "+questionsAsked);
					console.log("Score: "+returnValues["score"]);
					console.log("Attempts: "+returnValues["attempts"]);
					
				} else {
					/* UPDATE TO ERROR PAGE? */
					console.log("Error Returning SET EOC");
				}
			}
			
			console.log("Calling SAVE EOC Data...");
			
			var parameters="cbtusername="+ user.username;
			parameters +="&chapter="+ chapterNum;
			parameters +="&course="+ course.course_abv_english;		
			xhttp.open("POST","../course_data/setEOCData.asp",false);
			xhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
			xhttp.send(parameters);	
		}
		else
		{
			var objectiveNum = chapterNum-1;	
			if(tracking == "2004")
			{

				/*** Call Save Data Functions for QuizScore: ***/
				console.log("Calling LMS Set Value: " +"cmi.objectives."+objectiveNum+".score.raw"+" - Value: "+ score);
				doSetValue("cmi.objectives."+objectiveNum+".score.raw", score);
				doCommit();
				
			}
			else if(tracking == "1.2")
			{
				/*** Call Save Data Functions for QuizScore: ***/
				doLMSSetValue("cmi.objectives."+objectiveNum+".score.raw", score);
				doLMSCommit();
			}
			else
			{
				return false;
			}
			
			/*console.log("score "+chapterNum+": "+score);*/
		}
	}
	catch(err) {
		/*** THE DATA COULD NOT BE LOADED ***/
		return false;
	}
}

function setCertify() {
	
	console.log(".. Set Certify ..");
	
	try 
	{
		/*** GET THE TRACKING TYPE: ***/
		var tracking = course.tracking;

		if(tracking == "DB" && getQueryVariable("cbtusername") != "demo_user")
		{
			console.log("Calling certify ASP");
			
			/** CALL CERTIFY ASP **/
			/*** Call Save Data Functions for QuizScore, Quiz Attempts, Quiz Questions: ***/
			var xhttp;  
			var returnValues = new Array(); 

			if (window.XMLHttpRequest)
			{/*** code for IE7+, Firefox, Chrome, Opera, Safari ***/
				xhttp=new XMLHttpRequest();
			}
			else
			{/*** code for IE6, IE5 ***/
				xhttp=new ActiveXObject("Microsoft.XMLHTTP");
			}

			xhttp.onreadystatechange=function()
			{
				console.log("State: "+xhttp.readyState);
				console.log("Status: "+xhttp.status);
				console.log("Response: "+xhttp.responseText);
				
				/*** Append the Page Results to the Document: ***/
				if (xhttp.readyState==4 && xhttp.status==200)
				{
					console.log("Done ASP Validate Cert Call");
					var returnString = xhttp.responseText;
					console.log(returnString);
					/*** CHECK TO SEE IF THERE WAS AN ERROR RETURNED: ***/
					try{
						returnValues = eval ("(" + returnString + ")");
					} catch(e) {
						returnValues.push({
							key:   "error",
							value: "false"
						});
					}
					
					if (returnValues["error"] != undefined && returnValues["error"] != "" && returnValues["error"] != "false") {
						document.getElementById("cert_loading").style.display = "none";	
						document.getElementById("certifyDiv").style.display = "block";	
						document.getElementById("certifyDiv").innerHTML = "<font color='red'>There was an error processing your certificate.  Please notify YOW Canada Inc.</font>";	
						
					} else {
						document.getElementById("cert_loading").style.display = "none";	
						document.getElementById("certifyDiv").style.display = "block";	
	
						/*** PLAY CERTIFIED AUDIO ***/					
							
						var audio_src = "";
						var audioFile = "CERTIFIED.mp3";
						var fileTypeSplit = audioFile.lastIndexOf("."); 
						if (fileTypeSplit != -1 && user_language!=default_language && course.multilanguage != "1") audioFile = audioFile.substr(0, fileTypeSplit) + "_"+user_language+"."+ audioFile.substr(fileTypeSplit + 1);
						audio_src =  global.courseFilesPath+"audio/"+audioFile;
						
						document.getElementById('certifyAudio').innerHTML = "<source id='certifyAudioSource' src='"+audio_src+"' type='audio/mp3'>"
						
						var audioElement = document.getElementById('certifyAudio');
						audioElement.load();
					}						
				}
				else {
					console.log("ASP statechange....");
				}
			}
			
			var parameters="cbtusername="+ user.username;
			parameters +="&course="+ course.course_abv_english;
			xhttp.open("POST","../course_data/validateCertify.asp?cbtusername="+ user.username,true);
			xhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
			xhttp.send(parameters);	
			
			console.log("end of ASP xml init");
		}
		else
		{			
			var finalScore = 0;
			for(var i= 0; i<course.chapters; i++){
				finalScore = finalScore+(Number(user.quizArray[i][0]));
			}
			finalScore = finalScore/course.chapters;			
			
			/*** Call Save Data Functions for Status And (2004) Success Status: ***/
				
			setDataValue("status", "completed");	
				
			setDataValue("score.min", 0);
			setDataValue("score.max", 100);
			setDataValue("score.raw", finalScore);
			
			if(tracking == "2004")
			{
				doSetValue("cmi.success_status", "passed");			
				doSetValue("cmi.score.scaled", finalScore/100);	
				doCommit();			
			}
						
			var temp_cert = new Date();

			setDataValue("cert_date", temp_cert.getFullYear()+'/'+(temp_cert.getMonth()+1)+'/'+temp_cert.getDate());	
			user.cert_date = temp_cert.getFullYear()+'/'+(temp_cert.getMonth()+1)+'/'+temp_cert.getDate();
			
			setDataValue("exit", "suspend");
			
			/*** SEND SCORM COMPLETE TO YOW DB ***/
			console.log("111b*************** CALLING JSON FUNCTION: Set Trainee Complete *******************/");	
			$.fn.setSCORMComplete(user.username, user.fullName, course.companyName, course.course_abv_english, course.course_abv, course.scorm_package);	
			
			/*console.log("score "+chapterNum+": "+score);*/
			
			/* CHECK IF SET WAS SUCCESSFUL? */
			document.getElementById("cert_loading").style.display = "none";	
			document.getElementById("certifyDiv").style.display = "block";		
		}
	}
	catch(err) {
		/*** THE DATA COULD NOT BE LOADED ***/
		console.log("Error calling cert: "+err);
		return false;
	}	
}

function getScormAvailableCallback(json){
	console.log("111a--- JSONP RESPONSE ----");
	console.log(json);
	course.scormTrainees = json["available"];
	course.scormExpiry = json["date"];		
}


$.fn.getScormAvailable = function(fCompanyName, fCourse) {
	console.log("111a--- JSON AJAX --- "+fCompanyName+" "+fCourse );
	$.ajax({
		url: "https://www.yowcanada.com/ASP TEST/course_data/getSCORMAvailable.asp?company="+fCompanyName+"&course="+fCourse,
	  dataType: "jsonp"
	});
}

function setSCORMCompleteCallback(json){
	console.log("111b--- JSONP RESPONSE: Set Trainee Complete ----");
	console.log(json);	
}

$.fn.setSCORMComplete = function(fUsername, fFullName, fCompanyName, fCourse, fCourseVersion,fSCORMPackage) {
	console.log("111b--- JSON AJAX: Set Scorm --- "+fCompanyName+" "+fCourse );
	$.ajax({
		url: "https://www.yowcanada.com/ASP TEST/course_data/record_scorm_trainee.asp?cbtusername="+fUsername+"&fullname="+fFullName+"&company="+fCompanyName+"&course="+fCourse+"&course_version="+fCourseVersion+"&scorm_package="+fSCORMPackage,
	  dataType: "jsonp"
	});
}



