/*
************************************************************************************************************
COURSE/TRAINEE OBJECTS:
************************************************************************************************************
*/
/*****************************************************
	TRAINEE OBJECT:

	Store the User information

*****************************************************/
function Trainee() {

	this.username = ""; 	/* Trainee's Username */
    this.fullName = ""; 	/* Trainee's Full Name */
	
	this.status = 0; 		/* The Status of the Trainee (0-2 = IP, 4 = Certified) */
	this.lpv = "";  		/* Last Page Viewed/Bookmark */

	this.company = ""; 		/* Trainee's Company Name */
	this.adminID = "";		/* Administrator's ID - Used For Customization */
	this.adminEmail = ""; 	/* Administrator's Email */
	this.quizThresh = 0; 	/* The Minimum Score Required to Pass and EOC Quiz */
	this.expiryCycle = 2;	/* The Expiry Cycle for Course Certificates */
	this.forced_language = "";
	this.autonav = true;
	this.disable_autonav = false;
	this.course_version = ""; 	/* Trainee's course_type (TDG DRIVERS) */
	
	this.cert_date = ""

	/*** STORE THE QUIZ SCORE AND ATTEMPTS IN A MULTI-DIMENSIONAL ARRAY: X = SCORE Y = ATTEMPTS ***/
	//CAN THIS BE DYNAMIC TO ALLOW FOR 1-9+ CHAPTERS?
	/*
	this.quizArray = [quizChapers];					//initialise the variable
	for(i = 0; i < this.quizArray.length; i++){
		this.quizArray[i] = [0,0];					//populate the array
	}
	*/
	this.quizArray = [];

	this.found = false;

	console.log("** Initialising Trainee Data **");
	
	initialiseTraineeData();
	
	/*** GET THE USERDATA FUNCTION: ***/
	this.loadData = function(courseChapters) {
		
		console.log("** Loading Trainee Data **");
		
		/*** LOAD THE USERDATA USING THE KEY VALUE FOR THE TRACKING DATA MODEL: ***/
		this.username = getDataValue("username");
		this.fullName = getDataValue("full_name");

		if (initialFound == undefined) {
			if (this.username != "" && this.username != undefined) {
				initialFound = true;
			}
			else {
				initialFound =false;
			}
		}
		this.found = initialFound;
		
		if (course.tracking == "2004" || course.tracking == "1.2")
		{
			console.log("Setting exit....");
			setDataValue("exit", "suspend");			
		}
		this.course_version = getDataValue("course_version");
		this.status = getDataValue("status");		
		this.lpv = getDataValue("lpv");
				
		this.company = getDataValue("company");
		this.expiryCycle = getDataValue("expiry_cycle");
		this.quizThresh = getDataValue("quiz_thresh");
		this.adminID = getDataValue("adminID");
		this.adminEmail = getDataValue("admin_email");
		this.forced_language = getDataValue("forced_language");
		if(getDataValue("disable_autonav") == "True") {
			this.autonav = false;
			this.disable_autonav = true;
		}
		else {
			this.disable_autonav = false;
		}
		
		this.cert_date = getDataValue("cert_date");
		

		/*** SPECIAL quizScore CALLS: ***/
		/*** USES THE COURSE NUMBER OF CHAPTERS TO GET ALL QUIZSCORES: ***/
		
		for(var i= 0; i<courseChapters; i++) 
		{
			/*** MAKE THE QUIZ ARRAY A MULTI-DIMENSIONAL ARRAY: ***/
			this.quizArray[i] = [];
			
			this.quizArray[i][0] = getQuizValue(i+1);
			
			if(course.tracking == "DB") 
			{
				try {
					this.quizArray[i][1] = DBValues["QuizArray"][i]["QuizAttempts"];
					
				} catch(e) {
					/*** Error getting QuizAttempts: ***/
					this.quizArray[i][1] = 0;					
				}
			}
			else
			{	
				/*** SET ATTEMPTS TO 0 FOR EACH CHAPTER IF TRACKING IS LMS ***/
				this.quizArray[i][1] = 0;
			}
		}
		
		/*** INITIALIZE COURSE SPECIFIC USER DATA ***/
		try{
			getCourseUserData();
		} catch(e) {
			console.log("There was an error getting the Course Specific User Data: "+e);
		}
    };
	console.log("saving data....");
	/*** WRITE SPECIFIC VATIABLES/ALL VARIABLES? ***/
	this.saveData = function() {

    };
}

/*****************************************************
	COURSE OBJECT:

	Store the Course information

*****************************************************/
function Course() {
	this.title = "Online Training"; //Course Main Title
	this.course_abv_english = "TEST"; //The Course Abvr/Directory
	this.course_abv = "TEST"; //The Course Abvr/Directory
	this.chapters = 1; //Number of Chapters in the COURSE
	this.tracking = "DB"; //Data Storage Method: YOW DB, SCORM 2004/1.2?
	this.multilanguage = 1; //1 = Single Language, 2 = Bilingual, 3 = Multilanguage
	this.showSlideReference = 0; //0 hide "Open Slide" button, 1= show "Open Slide" button
	this.default_lang = "ENGLISH";
	this.default_switch_lang = "FRENCH";
	/*** Array of Chapter Titles: ***/
	this.chapterTitles = [];
		
	/*** SCORM VARIABLES: ***/
	this.scorm_abv = "SCORM";
	this.scorm_title_english = "Test SCORM Course E";
	this.scorm_title_french = "Test SCORM Course F";	
	
	this.companyName = "Test Company";
	this.scormExpiry = "some date";
	this.scormTrainees = 1;	
	this.expiryCycle = 2;
	this.quizThresh = "";
	this.adminName = "";
	this.adminEmail = "";
	this.adminPhone = "";	
	this.scorm_forced_lang = "";
	this.scorm_disable_autonav = "";
	this.scorm_course_version = "";
	this.scorm_id = "";
	this.scorm_package = "";
	this.scorm_debug = "";

	/*** LOAD THE DATA FROM THE "course_sco.xml" file: ***/
	this.loadData = function () {
		
		console.log("** Loading Course Data **");
		
		var courseXML = loadXMLDoc("course_sco.xml");
		
		if(courseXML.getElementsByTagName("course")[0].getAttribute("default_lang") != undefined) {this.default_lang =  courseXML.getElementsByTagName("course")[0].getAttribute("default_lang");}
		if(courseXML.getElementsByTagName("course")[0].getAttribute("default_switch_lang")) {this.default_switch_lang =  courseXML.getElementsByTagName("course")[0].getAttribute("default_switch_lang");}
		
		if ((user_language==undefined) || (user_language=="") || (user_language==this.default_lang) || user_language === "FALSE") {
			user_language = this.default_lang;
			switch_lang = this.default_switch_lang;	 /* CAN BE SET IN THE COURSE XML AS SECONDARY LANG */
		} 
		else {
			switch_lang = this.default_lang; /* CAN BE SET IN COURSE XML AS PRIMARY LANG? */
		}
				
		if (courseXML.getElementsByTagName("course_abv")[0].getElementsByTagName(user_language)[0] !== undefined) {
			this.course_abv = courseXML.getElementsByTagName("course_abv")[0].getElementsByTagName(user_language)[0].childNodes[0].nodeValue;
		} else {
			if(courseXML.getElementsByTagName("course_abv")[0].getElementsByTagName(this.default_lang)[0] !== undefined)
			{
				this.course_abv = courseXML.getElementsByTagName("course_abv")[0].getElementsByTagName(this.default_lang)[0].childNodes[0].nodeValue;		
			} else {
				this.course_abv = courseXML.getElementsByTagName("course_abv")[0].childNodes[0].nodeValue;		
			}				
		}
		
		if (courseXML.getElementsByTagName("course_abv")[0].getElementsByTagName("ENGLISH")[0] !== undefined) {
			this.course_abv_english = courseXML.getElementsByTagName("course_abv")[0].getElementsByTagName("ENGLISH")[0].childNodes[0].nodeValue;
		} else {
			this.course_abv_english = courseXML.getElementsByTagName("course_abv")[0].childNodes[0].nodeValue;						
		}
				
		this.chapters = courseXML.getElementsByTagName("chapters")[0].getAttribute("number");
		this.tracking =  courseXML.getElementsByTagName("course")[0].getAttribute("tracking");
		this.multilanguage =  courseXML.getElementsByTagName("course")[0].getAttribute("multilanguage");
		if (courseXML.getElementsByTagName("course")[0].getAttribute("showSlideReference") !== undefined) {
			this.showSlideReference = courseXML.getElementsByTagName("course")[0].getAttribute("showSlideReference");
        }
			
		this.title = courseXML.getElementsByTagName("title")[0].childNodes[0].nodeValue;
		if (courseXML.getElementsByTagName("title")[0].getElementsByTagName(user_language)[0] !== undefined) {
			this.title = courseXML.getElementsByTagName("title")[0].getElementsByTagName(user_language)[0].childNodes[0].nodeValue;
		} else {
			if(courseXML.getElementsByTagName("title")[0].getElementsByTagName(this.default_lang)[0] !== undefined)
			{
				this.title = courseXML.getElementsByTagName("title")[0].getElementsByTagName(this.default_lang)[0].childNodes[0].nodeValue;		
			} else {
				this.title = courseXML.getElementsByTagName("title")[0].childNodes[0].nodeValue;		
			}				
		}

		/*** FOR EACH CHAPTER ADD AN ARRAY NODE WITH CHAPTER TITLE: ***/
		for(var i=0; i<this.chapters; i++)
		{
			if (courseXML.getElementsByTagName("chapter")[i].getElementsByTagName("title")[0].getElementsByTagName(user_language)[0] !== undefined) {
				this.chapterTitles[i] = courseXML.getElementsByTagName("chapter")[i].getElementsByTagName("title")[0].getElementsByTagName(user_language)[0].childNodes[0].nodeValue;
			} else {
				if(courseXML.getElementsByTagName("chapter")[i].getElementsByTagName("title")[0].getElementsByTagName(this.default_lang)[0] !== undefined)
				{
					this.chapterTitles[i] = courseXML.getElementsByTagName("chapter")[i].getElementsByTagName("title")[0].getElementsByTagName(this.default_lang)[0].childNodes[0].nodeValue;		
				} else {
					this.chapterTitles[i] = courseXML.getElementsByTagName("chapter")[i].getElementsByTagName("title")[0].childNodes[0].nodeValue;		
				}				
			}			
		}
				
		/*
		var scormNode = courseXML.getElementsByTagName("scorm")[0].childNodes[0].nodeValue;
		var SCORMNode = courseXML.getElementsByTagName("scorm")[0].attributes;
		*/
		
		if(courseXML.getElementsByTagName("course_abv")[0].getElementsByTagName("ENGLISH")[0] !== undefined)
		{
			this.scorm_abv = courseXML.getElementsByTagName("course_abv")[0].getElementsByTagName("ENGLISH")[0].childNodes[0].nodeValue;		
		} else {
			this.scorm_abv = courseXML.getElementsByTagName("course_abv")[0].childNodes[0].nodeValue;		
		}
		
		if(courseXML.getElementsByTagName("title")[0].getElementsByTagName("ENGLISH")[0] !== undefined)
			{
				this.scorm_title_english = courseXML.getElementsByTagName("title")[0].getElementsByTagName("ENGLISH")[0].childNodes[0].nodeValue;		
			} else {
				this.scorm_title_english = courseXML.getElementsByTagName("title")[0].childNodes[0].nodeValue;		
			}				
		
		if (courseXML.getElementsByTagName("title")[0].getElementsByTagName("FRENCH")[0] !== undefined) {
			this.scorm_title_french = courseXML.getElementsByTagName("title")[0].getElementsByTagName("FRENCH")[0].childNodes[0].nodeValue;
		} else {
			if(courseXML.getElementsByTagName("title")[0].getElementsByTagName("ENGLISH")[0] !== undefined)
			{
				this.scorm_title_french = courseXML.getElementsByTagName("title")[0].getElementsByTagName("ENGLISH")[0].childNodes[0].nodeValue;		
			} else {
				this.scorm_title_french = courseXML.getElementsByTagName("title")[0].childNodes[0].nodeValue;		
			}				
		}		
				
		if(this.tracking != "DB" ){
			var scormXML = loadXMLDoc("course_specific/all_courses/company_info.xml");
			
			this.companyName = scormXML.getElementsByTagName("scorm")[0].getElementsByTagName("company")[0].childNodes[0].nodeValue;
			this.scormExpiry = scormXML.getElementsByTagName("scorm")[0].getElementsByTagName("scorm_date")[0].childNodes[0].nodeValue;
			
			this.expiryCycle = scormXML.getElementsByTagName("scorm")[0].getElementsByTagName("expiry_cycle")[0].childNodes[0].nodeValue;
			
			this.quizThresh = scormXML.getElementsByTagName("scorm")[0].getElementsByTagName("quiz_thresh")[0].childNodes[0].nodeValue;
			
			this.adminName = scormXML.getElementsByTagName("scorm")[0].getElementsByTagName("name")[0].childNodes[0].nodeValue;
			this.adminEmail = scormXML.getElementsByTagName("scorm")[0].getElementsByTagName("email")[0].childNodes[0].nodeValue;
			this.adminPhone = scormXML.getElementsByTagName("scorm")[0].getElementsByTagName("phone")[0].childNodes[0].nodeValue;
			
			try{
			if(scormXML.getElementsByTagName("scorm")[0].getElementsByTagName("scorm_id")[0].childNodes[0] !== undefined) {
				this.scorm_id = scormXML.getElementsByTagName("scorm")[0].getElementsByTagName("scorm_id")[0].childNodes[0].nodeValue;
			}
			} catch(e) {console.log(e);}
			
			try{
			if(scormXML.getElementsByTagName("scorm")[0].getElementsByTagName("forced_langauge")[0].childNodes[0] !== undefined) {
				this.scorm_forced_lang = scormXML.getElementsByTagName("scorm")[0].getElementsByTagName("forced_langauge")[0].childNodes[0].nodeValue;
			}
			} catch(e) { console.log(e); }
			
			try{
			if(scormXML.getElementsByTagName("scorm")[0].getElementsByTagName("disable_autonav")[0].childNodes[0] !== undefined) {
				this.scorm_disable_autonav = scormXML.getElementsByTagName("scorm")[0].getElementsByTagName("disable_autonav")[0].childNodes[0].nodeValue;
			}
			}  catch(e) { console.log(e); }
			
			try {
			if(scormXML.getElementsByTagName("scorm")[0].getElementsByTagName("course_version")[0].childNodes[0] !== undefined) {
				this.scorm_course_version = scormXML.getElementsByTagName("scorm")[0].getElementsByTagName("course_version")[0].childNodes[0].nodeValue;
			}
			}  catch(e) { console.log(e); }
			
			try{
				if(scormXML.getElementsByTagName("scorm")[0].getElementsByTagName("package_version")[0].childNodes[0] !== undefined) {
					this.scorm_package = scormXML.getElementsByTagName("scorm")[0].getElementsByTagName("package_version")[0].childNodes[0].nodeValue;
				}
			} catch(e) {console.log(e);}
									
			/*** CALLING GET SCORM AVAILABLE FUNCTION: ***/
			console.log("111a*************** CALLING JSON FUNCTION *******************/");	
			console.log("course_title: "+this.course_abv_english);
			$.fn.getScormAvailable(this.companyName, this.course_abv_english);			
			
			var scormDebugFile = new XMLHttpRequest();
			scormDebugFile.open("GET", 'scorm_debug.txt', false);
			scormDebugFile.send();
			if (scormDebugFile.status==200) {								
				this.scorm_debug = scormDebugFile.responseText;
			}
		}
		

		/*
		printToConsole(this);
		*/
		
	}
	/* END LOAD DATA FUNCTION */
	
	/*UPDATE THE TITLE WITH THE VERSION TITLE */
	this.updateTitle = function(fVersion) {
		
		var courseXML = loadXMLDoc("course_sco.xml");
		
		var fTitles = courseXML.getElementsByTagName("title");
		for(var i=0; i<fTitles.length; i++) {
			
			if(fTitles[i].parentNode.nodeName=="course" && fTitles[i].getAttribute("version")==fVersion) {
				courseMessage("Version Title Found - Updating Course Title",3);
				if (fTitles[i].getElementsByTagName(user_language)[0] !== undefined) {
					this.title = fTitles[i].getElementsByTagName(user_language)[0].childNodes[0].nodeValue;
				} else {
					if(fTitles[i].getElementsByTagName(this.default_lang)[0] !== undefined)
					{
						this.title = fTitles[i].getElementsByTagName(this.default_lang)[0].childNodes[0].nodeValue;		
					} else {
						this.title = fTitles[i].childNodes[0].nodeValue;		
					}				
				}
				courseMessage("Title: "+this.title ,3);	
			}
					
		}
		
		
	}
}

