// Sample Media Player using HTML5's Media API
// 
// Ian Devlin (c) 2012
// http://iandevlin.com
// http://twitter.com/iandevlin
//
// This was written as part of an article for the February 2013 edition of .net magazine (http://netmagazine.com/)

// Wait for the DOM to be loaded before initialising the media player
//document.addEventListener("DOMContentLoaded", function() { initialiseMediaPlayer(); }, false);

// Variables to store handles to various required elements
var mediaPlayer;
var playPauseBtn;
var muteBtn;
var progressBar;
var volumeBar;
var fullScreenButton;
var animStage;
var audioFile;	//set audioFile.mp3 depending on Tranee current course/module/page  -shoulg get form XML file

var auto_play = true;




//****************************************************************************
//READ XML FILE
//****************************************************************************


function initialiseMediaPlayer() {


	// Get a handle to the player
	mediaPlayer = document.getElementById('mediaAudio');
	
	// Get handles to each of the buttons and required elements
	playPauseBtn = document.getElementById('playPauseButton');
	muteBtn = document.getElementById('muteButton');
	progressBar = document.getElementById('progressBar');
	volumeBar = document.getElementById('volumeBar');
	fullScreenButton = document.getElementById('fullScreenButton');
	
	// Hide the browser's default controls
	mediaPlayer.controls = false;
	
	// Hide the Mute button's controls if on iProduct
	if (/iphone|ipod|ipad/.test( window.navigator.userAgent.toLowerCase())){
		muteBtn.style.visibility = "hidden";
		volumeBar.style.visibility = "hidden";
	}
	// Show the fullScreenButton button if on Android
	if (/android/.test( window.navigator.userAgent.toLowerCase())){
		fullScreenButton.style.visibility = "visible";
	}
	else{
		fullScreenButton.style.visibility = "hidden";
	}
	
	
	// Add a listener for the timeupdate event so we can update the progress bar
	mediaPlayer.addEventListener('timeupdate', updateProgressBar, false);	
	mediaPlayer.addEventListener('timeupdate', function(){ setAnimationTime(mediaPlayer.currentTime*1000);}, false);
	mediaPlayer.addEventListener('canplay', function(){ setAnimationTotalTime(this.duration); }, false);
	mediaPlayer.addEventListener('canplaythrough', function(){ setAnimationTotalTime(this.duration);  }, false);
		
	// Add a listener for the play and pause events so the buttons state can be updated
	mediaPlayer.addEventListener('play', function(){  
		setAnimationPaused(false); 
		changeButtonType(playPauseBtn, 'pause', ''); 
		
		try {
			animation_play_slide();
		} catch (e) { 
			console.log('Error playing custom animation'); 
			console.log(e);
		}
		try { 
			//stageAdobe.play();
			stageAdobe.tickOnUpdate = true;
			//createjs.Ticker.setPaused(false);
			
		} catch (e) { 
			console.log('Error playing adobe animation'); 
			console.log(e);
		}
	}, false);
		
	mediaPlayer.addEventListener('playing', function() {
		// Change the button to be a pause button
		console.log("playing...");
		changeButtonType(playPauseBtn, 'pause', '');
	}, false);
	mediaPlayer.addEventListener('pause', function() {
		// Change the button to be a play button
		changeButtonType(playPauseBtn, 'play', '');	
		console.log("Current Media Time: "+mediaPlayer.currentTime);
		setAnimationPaused(true);	
		 
		try {
			animation_pause_slide();
		} catch (e) { 
			console.log('Error pausing custom animation'); 
			console.log(e);
		}
		try {
			//stageAdobe.stop();           
			stageAdobe.tickOnUpdate = false;    
			//createjs.Ticker.setPaused(true);
		} catch (e) { 
			console.log('Error playing adobe animation'); 
			console.log(e);
		}
	}, false);
	
	mediaPlayer.addEventListener('durationchange', function() {
		// Change the button to be a play button when the media is changed.
		setAnimationPaused(true);
		changeButtonType(playPauseBtn, 'play', '');			
	}, false);
	
	// need to work on this one more...how to know it's muted?
	mediaPlayer.addEventListener('volumechange', function(e) { 
		// Update the button to be mute/unmute
		if (mediaPlayer.muted) changeButtonType(muteBtn, 'unmute', '');
		else changeButtonType(muteBtn, 'mute', '');
	}, false);	
	
	
	mediaPlayer.addEventListener('ended', function() {  this.pause(); }, false);		
	/*
	mediaPlayer.addEventListener('abort', function(){ console.log("abort........."); }, false);
	mediaPlayer.addEventListener('canplay', function(){ console.log("canplay........."); }, false);
	mediaPlayer.addEventListener('canplaythrough', function(){ console.log("canplaythrough........."); }, false);
	mediaPlayer.addEventListener('durationchange', function(){ console.log("durationchange........."); }, false);
	mediaPlayer.addEventListener('emptied', function(){ console.log("emptied........."); }, false);
	mediaPlayer.addEventListener('encrypted ', function(){ console.log("encrypted ........."); }, false);
	mediaPlayer.addEventListener('ended', function(){ console.log("ended........."); }, false);
	mediaPlayer.addEventListener('error', function(){ console.log("error........."); }, false);
	mediaPlayer.addEventListener('interruptbegin', function(){ console.log("interruptbegin........."); }, false);
	mediaPlayer.addEventListener('interruptend', function(){ console.log("interruptend........."); }, false);
	mediaPlayer.addEventListener('loadeddata', function(){ console.log("loadeddata........."); }, false);
	mediaPlayer.addEventListener('loadedmetadata', function(){ console.log("loadedmetadata........."); }, false);
	mediaPlayer.addEventListener('loadstart', function(){ console.log("loadstart........."); }, false);
	mediaPlayer.addEventListener('mozaudioavailable', function(){ console.log("mozaudioavailable........."); }, false);
	mediaPlayer.addEventListener('pause', function(){ console.log("pause........."); }, false);
	mediaPlayer.addEventListener('play', function(){ console.log("play........."); }, false);
	mediaPlayer.addEventListener('playing', function(){ console.log("playing........."); }, false);
	mediaPlayer.addEventListener('progress', function(){ console.log("progress........."); }, false);
	mediaPlayer.addEventListener('ratechange', function(){ console.log("ratechange........."); }, false);
	mediaPlayer.addEventListener('seeked', function(){ console.log("seeked........."); }, false);
	mediaPlayer.addEventListener('seeking', function(){ console.log("seeking........."); }, false);
	mediaPlayer.addEventListener('stalled', function(){ console.log("stalled........."); }, false);
	mediaPlayer.addEventListener('suspend', function(){ console.log("suspend........."); }, false);
	mediaPlayer.addEventListener('timeupdate', function(){ console.log("timeupdate........."); }, false);
	mediaPlayer.addEventListener('volumechange', function(){ console.log("volumechange........."); }, false);
	mediaPlayer.addEventListener('waiting', function(){ console.log("waiting........."); }, false);
	*/
	
	//Add a click event to move to current click in the progress bar
	progressBar.addEventListener("mousedown", function(){
				
		changeButtonType(playPauseBtn, 'pause', '');
		mediaPlayer.play();
		document.onmousemove = function(e) {
			setPlayProgress(e.pageX);
		}
		 
		document.onmouseup = function() {
			document.onmousemove = null;
			document.onmouseup = null;	
		}
	}, true);
	progressBar.addEventListener("mouseup", function(e){
		setPlayProgress(e.pageX);
    }, true);
	volumeBar.addEventListener("mousedown", function(){
		document.onmousemove = function(e) {
			changeVolume(e.pageX);
		}
		 
		document.onmouseup = function() {
			document.onmousemove = null;
			document.onmouseup = null;	
		}
	}, true);
	volumeBar.addEventListener("mouseup", function(e){
		changeVolume(e.pageX);
    }, true);
	
}

	function togglePlayPause() {
		if(!tickerOn) {
			// If the mediaPlayer is currently paused or has ended
			if (mediaPlayer.paused || mediaPlayer.ended) {
				// Change the button to be a pause button
				changeButtonType(playPauseBtn, 'pause', '');
				// Play the media
				mediaPlayer.play();
				AdobeAnimateSlidePlay();
			}
			// Otherwise it must currently be playing
			else {
				// Change the button to be a play button
				changeButtonType(playPauseBtn, 'play', '');
				// Pause the media
				console.log("Pause 1");
				mediaPlayer.pause();
				AdobeAnimateSlidePause();
			}
		} else {
			if (createjs.Ticker.getPaused() || elapsedTime > totalTime) {
				// Change the button to be a pause button
				changeButtonType(playPauseBtn, 'pause', '');
				// Play the media
				setAnimationPaused(false);
			}
			// Otherwise it must currently be playing
			else {
				// Change the button to be a play button
				changeButtonType(playPauseBtn, 'play', '');
				// Pause the media
				//console.log("Pause 1");
				setAnimationPaused(true);
			}			
		}
	}

// Stop the current media from playing, and return it to the start position
function stopPlayer() {
	//console.log("Pause 2");
	mediaPlayer.pause();
	mediaPlayer.currentTime = 0;
	AdobeAnimateSlideSeekAndStop(0);
}

// Changes the volume on the media player
function changeVolume(ev) {
	var newPercent = Math.max(0, Math.min(1, (ev - findPosX(volumeBar)) / volumeBar.offsetWidth));
	mediaPlayer.volume = newPercent 
	//progressBar.style.width = newPercent * (progressBar.offsetWidth - 2)  + "px";
	volumeBar.value = newPercent;
	
}

// Toggles the media player's mute and unmute status
function toggleMute() {
	if (mediaPlayer.muted) {
		// Change the cutton to be a mute button
		changeButtonType(muteBtn, 'mute', '');
		// Unmute the media player
		mediaPlayer.muted = false;
		volumeBar.value = mediaPlayer.volume;
	}
	else {
		// Change the button to be an unmute button
		changeButtonType(muteBtn, 'unmute', '');
		// Mute the media player
		mediaPlayer.muted = true;
		volumeBar.value = 0;
	}
}

// Replays the media currently loaded in the player
function replayMedia() {
	resetPlayer();
	if(!tickerOn) {
		mediaPlayer.play();
		AdobeAnimateSlideSeekAndPlay(0);		
	} else {
		setAnimationPaused(false);
	}
}

// Update the progress bar
function updateProgressBar() {
	// Work out how much of the media has played via the duration and currentTime parameters
	var percentage;
	if(!tickerOn) {
		percentage =  mediaPlayer.currentTime/mediaPlayer.duration*1000000;
	} else {
		percentage =  elapsedTime/totalTime*1000000;
	}
	// Update the progress bar's value
	try {
		progressBar.value = percentage;
		}catch(err){
			console.log("Error resetting slide; progressBar might not exist");
		}
	
	//console.log("Percentage:"+percentage);
	// Update the progress bar's text (for browsers that don't support the progress element)
	progressBar.innerHTML = percentage + '% played';
	
	if(percentage > 999999 )
	{
		checkAutoNav();
	}
}

//move to click locaton on the progress bar
function setPlayProgress(ev){
	try {
		/* HANDLE AUDIO VS TICKER: */
		var newPercent = Math.max(0, Math.min(1, (ev - findPosX(progressBar)) / progressBar.offsetWidth));;
		if(!tickerOn) {
			mediaPlayer.currentTime = newPercent * mediaPlayer.duration;
		} else {
			elapsedTime = newPercent * totalTime;
		}
		
		
		AdobeAnimateSlideSeekAndPlay(mediaPlayer.currentTime);



		/*code use to seek to Adobe Animate DOES NOT WORK*/
		//try{
		//	
		//	console.log('adobe time:'+newPercent * stageAdobe.getDuration()); 
		//	stageAdobe.seek(newPercent * stageAdobe.getDuration()/10); 
		//	stageAdobe.update();
		//	stageAdobe.play();
		//}catch(e){
		//	console.log('Error moving adobe animation'); 
		//	console.log(e);
		//}
		
		//progressBar.style.width = newPercent * (progressBar.offsetWidth - 2)  + "px";
		console.log("mediaTime: " + mediaPlayer.currentTime);
		console.log("animationTime: " + elapsedTime);
		
		updateProgressBar();
	} catch(e) { 
		console.log("Error setting slide progress"); 
	}
}
// Get objects position on the page
function findPosX(obj) {
  var curleft = obj.offsetLeft;
  while(obj = obj.offsetParent) {
	curleft += obj.offsetLeft;
  }
  return curleft;
}

// Updates a button's title, innerHTML and CSS class to a certain value
function changeButtonType(btn, value, txt) {
	btn.title = value;
	btn.innerHTML = txt;
	btn.className = value;
}

// Loads a video item into the media player
function loadVideo() {
	for (var i = 0; i < arguments.length; i++) {
		var file = arguments[i].split('.');
		var ext = file[file.length - 1];
		// Check if this media can be played
		if (canPlayVideo(ext)) {
			// Reset the player, change the source file and load it
			resetPlayer();
			mediaPlayer.src = arguments[i];
			mediaPlayer.load();
			break;
		}
	}
}

// Checks if the browser can play this particular type of file or not
function canPlayVideo(ext) {
	var ableToPlay = mediaPlayer.canPlayType('audio/' + ext);
	if (ableToPlay == '') return false;
	else return true;
}

// Resets the media player
function resetPlayer() {
	try {
		// Reset the progress bar to 0
		progressBar.value = 0;
		// Move the media back to the start
		if(!tickerOn) {
			mediaPlayer.currentTime = 0;
		} else {
			elapsedTime = 0;
		}
		// Ensure that the play pause button is set as 'play'
		changeButtonType(playPauseBtn, 'pause', '');
		
		try {
			animation_reset_slide();
		} catch (e) { 
			console.log('Error resetting custom animation'); 
			console.log(e);
		}
		
		try{
			stageAdobe.seek(0); 
			stageAdobe.update();
			stageAdobe.play();
		}catch(e){
			console.log('Error resetting adobe animation'); 
			console.log(e);
		}
		
	} catch(e) { 
		console.log("Error resetting slide");
	}
}

function getAudioFile(){
	//audioFile = Course.Title + "/M" Course.Chapter + "P" Tranee.lpv + ".mp3";//should get audio path from XMl when reading to populate the TEXT file 	
	return audioFile;
}


function addAnimControls(swiffyobject){
	try{
		animStage = new swiffy.Stage(document.getElementById('swiffycontainer'),
			  swiffyobject, {});
		animStage.start(); 
	}catch(err){}
	try{
		document.getElementById("replayButton").addEventListener('click', animReplay);	
		mediaPlayer.addEventListener('playing', animPlaying);
		mediaPlayer.addEventListener('pause', animPaused);
	}catch(err){}
}
function animReplay(){
	animStage.destroy();
	animStage = new swiffy.Stage(document.getElementById('swiffycontainer'),swiffyobject, {});
	animStage.start();
}
function animPlaying(){
	animStage.start();
}
function animPaused(){
	animStage.pause();
}
function removeAnimControls(){
	try{
		animStage.destroy();
		document.getElementById("replayButton").removeEventListener('click', animReplay);	
		mediaPlayer.removeEventListener('playing', animPlaying);
		mediaPlayer.removeEventListener('pause', animPaused);
	}catch(err){}
}






//---------------------------------------------------------
// Custom Adobe Animate functions
//---------------------------------------------------------
function AdobeAnimateSlideSeekAndPlay(animationTime){
	try{

		let adobeIframe = document.getElementById("AdobeAnimateFrame");
		if (adobeIframe !== "undefined"){
			let fps=1; //fps=20; // sync fix
			if (typeof adobeIframe.contentWindow.getFps === "function"){
				fps = adobeIframe.contentWindow.getFps();
			}

			if (typeof adobeIframe.contentWindow.seekAndPlay === "function"){
				adobeIframe.contentWindow.seekAndPlay(Math.round(animationTime*fps));
			}
		}
	}
	catch(e){
		console.log("error in AdobeAnimateSlideSeekAndPlay");
	}
}
function AdobeAnimateSlidePause(){
	try{
		
		let adobeIframe = document.getElementById("AdobeAnimateFrame");
		if (adobeIframe !== "undefined"){
			if (typeof adobeIframe.contentWindow.pause === "function"){
				adobeIframe.contentWindow.pause();
			}
		}
	}
	catch(e){
		console.log("error in AdobeAnimateSlidePause e="+e);
	}
}
function AdobeAnimateSlidePlay(){
	try{

		let adobeIframe = document.getElementById("AdobeAnimateFrame");
		if (adobeIframe !== "undefined"){
			if (typeof adobeIframe.contentWindow.play === "function"){
				adobeIframe.contentWindow.play();
			}
		}
	}
	catch(e){
		console.log("error in AdobeAnimateSlidePlay");
	}
}
function AdobeAnimateSlideSeekAndStop(){
	try{

		let adobeIframe = document.getElementById("AdobeAnimateFrame");
		if (adobeIframe !== "undefined"){
			if (typeof adobeIframe.contentWindow.seekAndStop === "function"){
				adobeIframe.contentWindow.seekAndStop(0);
			}
		}
	}
	catch(e){
		console.log("error in AdobeAnimateSlideSeekAndStop");
	}
}
function AdobeAnimateResizeframe(){

	let slideWrapper = document.getElementsByClassName("slideWrapper")[0];
	if (slideWrapper !== null && slideWrapper !== undefined) {
		let slideWidth = slideWrapper.scrollWidth;
		let slideHeight = slideWrapper.scrollHeight;

		let adobeIframe = document.getElementById("AdobeAnimateFrame");
		if (adobeIframe !== "undefined" && adobeIframe !== null) {

			adobeIframe.style.width = slideWidth + 'px';
			adobeIframe.style.height = slideHeight + 'px';

		}
    }
}

window.addEventListener("resize",AdobeAnimateResizeframe);


