/******************************
	PRELOAD GLOBAL VARIABLES
*******************************/

var queue;
var assetManifest = {};
var totalAssets;
var assetsLoaded;
var totalAssetsLoaded;

var download_start;
var download_end;
var download_size;
var download_speed;

var slide_audio;

/*****************************************************************
	Add Asset FUNCTION:

	ADD A NEW ASSET TO THE PRELOAD QUE

******************************************************************/
function addAsset(id, src, type) {
	console.log("----------- Adding: " + id + " src: " + src);
	
	/** ADD THE ITEM TO THE asset array: **/
	assetManifest[id] = {src: src, type: type};
	totalAssets = totalAssets+1;
}

/*****************************************************************
	Reset Preload:

	Reset the Preload asset array, show the preload gif:

******************************************************************/
function resetPreload() {
	
	/** SHOW LOADING GIF: **/
	console.log("** Resetting Preload - showing loading gif **");
	//document.getElementById('preload').style.setProperty("visibility", "visible", "important");
	
	/** RESET QUE AND MANIFEST ARRAY: **/
	//console.log("Resetting Preload...");
	document.getElementById('mainCanvas').style.zIndex='6000';
	document.getElementById('slideWindow').style.zIndex='3000';
	/*adding this innerhtml as a "preloader" fix, will display loading GIF behind the Canvas element while audio and picture load.*/
	document.getElementById('slideWindow').innerHTML='<div class="preloadCenterDIV"><div class="preloadContent"><img src="'+global.courseFilesPath+'images/loader-1.gif"><br /><span id="preloadText" class="lLoadingSlide"> </span>.</div></div>';

	assetsLoaded = false;
	assetManifest = {};
	totalAssets = 0;
	totalAssetsLoaded = 0;
	//queue.removeAll();
	
	/*console.log("FileExists: " +fileExists("images/loader-12.gif"));*/
	
	//addAsset("loader", "images/loader-1.gif", "img");
	//addAsset("test", "M1_P1.ogg", "audio");
	
	//queue.installPlugin(createjs.Sound);
	
	/** DISABLE NEXT/PREV BUTTONS: **/
	document.getElementById("nextButton").disabled = true;
	document.getElementById("prevButton").disabled = true;

	/** PAUSE ANIMATIONS/AUDIO: **/
	document.getElementById('mediaAudio').innerHTML = "<source id='mediaAudioSource' src='' type='audio/mp3'>"

	mediaPlayer.load();
	if(mediaPlayer.currentTime) {
		mediaPlayer.currentTime = 0;
	}

	progressBar.value = 0;
	setAnimationTime(0);
}

/*****************************************************************
	PRELOAD START EVENT FUNCTION:

******************************************************************/
function startPreload() {
	console.log("---- Starting the Preload function **");
	//handleCompletePreload();
	download_start = new Date();
	
	
	
	/** LOOP THROUGH ASSET ARRAY AND LOAD EACH ASSET: **/
	for(key in assetManifest)
	{

		//console.log(assetManifest[key].src);
		//console.log(assetManifest[key].type);
		
		/** CREATE A NEW OBJECT TO CAUSE IT TO LOAD: **/
		if(assetManifest[key].type == "img") {
			console.log("-------- I key: " + key);
			var img = new Image();
			img.addEventListener('load', fileLoaded, false);
			img.src = assetManifest[key].src;
		}
		else if(assetManifest[key].type == "audio") {
			console.log("-------- A key: " + key);
			slide_audio = new Audio();
			//audio.onload = isAppLoaded; // It doesn't work!
			slide_audio.addEventListener('canplaythrough', fileLoaded, false); // It works!!
			slide_audio.src = assetManifest[key].src;
			
			//iOS safari fix: Safari needs to be told, with the load method, that the audio object
			//can be loaded when adding an audio source file. Once the audio file is loaded it 
			//will then trigger the event canplaythrough and continue on loading the slide
			slide_audio.load();

			//alert("Can play through audio without stopping " + slide_audio.readyState);
			if (slide_audio.readyState > 3) {
				alert("Can play through audio without stopping");
			}
				
			
		}
		else if(assetManifest[key].type == "video") {
			console.log("-------- V key: " + key);
			var video = new Audio();
			//audio.onload = isAppLoaded; // It doesn't work!
			video.addEventListener('canplaythrough', fileLoaded, false); // It works!!
			video.src = assetManifest[key].src;
		}
		else {
			console.log("type error: remove the item?");
		}
	}

	if(totalAssets == 0) {
		handleCompletePreload();
	}
	
	
	
}

/*****************************************************************
	FILE LOADED FUNCTION - CALLED ON CANPLAYTHROUGH OR LOAD EVENT:

******************************************************************/
function fileLoaded(event) {
	
	console.log("-------- This file is loaded...."+event.target.src);
	totalAssetsLoaded = totalAssetsLoaded+1;
	console.log("-------- Assets loaded: " + totalAssetsLoaded);
	console.log("-------- Total Assets: " + totalAssets);
	if(totalAssetsLoaded >= totalAssets) {
		/** DISABLE PRELOADING FOR NOW: **/
		handleCompletePreload();
	}
}

/*****************************************************************
	PRELOAD COMPLETE EVENT FUNCTION:

	USE THE LOADED ASSETS - REMOVE THE LOADING DIV:

******************************************************************/
function handleCompletePreload() {

	console.log("---- PreLoading Completed **");
	assetsLoaded = true;
	
	//console.log(assetManifest);
	//console.log(assetManifest['slideImg']);
	
	for(key in  assetManifest) {
		//console.log("item: " +assetManifest[key].src);
		if(document.getElementById(key)) {
			document.getElementById(key).src = assetManifest[key].src;
		}
	}
	
	/** ONCE LOADED: **/	
	if (assetsLoaded) {
		
		/** ENABLE BUTTONS: **/
		document.getElementById("nextButton").disabled = nextDisabled;
		document.getElementById("prevButton").disabled = prevDisabled;
		
		/** REMOVE PRELOAD DIV **/
		//document.getElementById('preload').style.visibility = "hidden";
	
		
		/** DISPLAY IMAGE IF APPLICABLE **/
		//var slideImage = queue.getResult("slideImg");
		if(assetManifest['slideImg']) {
			//console.log("Adding image....");
			document.getElementById('slideWindow').innerHTML = "<img id='slide_img' class= 'standardIMG' src='"+assetManifest['slideImg'].src+"' />";
			
		}	
		
		/*** PLAY THE LOADED AUDIO: ***/
		//var slideAudio = queue.getResult("slideAudio");
		if(assetManifest['slideAudio']) {
			//console.log("Audio File: " + assetManifest['slideAudio']);
			//console.log("Audio Source: " +assetManifest['slideAudio'].src);
			document.getElementById('mediaAudio').innerHTML = "<source id='mediaAudioSource' src='"+assetManifest['slideAudio'].src+"' type='audio/mp3'>"
			
			
			
			mediaPlayer.load();
			
		}
		else {
			/* IF THERE IS NO AUDIO? */
			document.getElementById('mediaAudio').innerHTML = "<source id='mediaAudioSource' src='' type='audio/mp3'>"
			setAnimationPaused(false);
			document.getElementById('mainCanvas').style.zIndex='4000';
			mediaPlayer.pause();
		}
		
		try {
			var transfer_rate = get_transfer_rate();
			
			console.log("Transfer Speed: "+transfer_rate+" Mbps");
			setDataValue("transfer_rate", transfer_rate);
			
			performance.clearResourceTimings();
		} catch (e) {
			console.log("resource timings not supported.");
			setDataValue("transfer_rate", "-1");
		}

		
	}
}

/*****************************************************************
	FILE SIZE AND TRANSFER SPEED FUNCTIONS:

	USING RESOURCE TIMING API: 

******************************************************************/


function get_transfer_rate() {
	
	
	/* WILL LOOP THROUGH PREFORMANCE RESOURCES AND CALCULATE TOTAL RESOURCE SIZE IN BYTES AND TOTAL RESPONSE TIME */
	/* RETURNS A TRANSFER RATE AS KBs */
	
	var total_size = 0;
	var total_response_time = 0;
	
	var resources = performance.getEntriesByType("resource");
	for (var i=0; i < resources.length; i++) {
		 total_size += resources[i].decodedBodySize;
		 var t;
		 t = t = (resources[i].startTime > 0) ? (resources[i].responseEnd - resources[i].startTime) : 0;
		 total_response_time += t;
		 
	}
		
	//console.log("Size:"+total_size);
	//console.log("Speed:"+total_response_time);
	
	return (total_size/1000/1000)/(total_response_time/1000)
}
