
/*
************************************************************************************************************
QUIZ OBJECTS:
************************************************************************************************************
*/

/*
MAKE SURE LOADING QUIZ LOOKS FOR THE SELECTED LANGUAGE DB/XML
*/

/*****************************************************
	Question OBJECT:
******************************************************/
function Question() {
	
	this.id = "";
	this.correct = [];	
	this.questionType = "";
    this.slide_ref_id = "";
    this.Question = "";
    this.dist = [];
	this.resp_true = "";
	this.resp_false = "";
	this.EOCQuestion = false;

	/*** IF Tracking = YOW then Load the Data From the DB with AJAX: ***/
	
	this.loadData = function(questionID) {
		
		if(course.tracking == "DB") {
			console.log("** Loading Quiz: "+questionID+" ** DB");
			var quizValues = new Array();  /* ARRAY TO STORE THE RETURNED VALUES FROM ASP CALL */
			
			var xhttp;  

			if (window.XMLHttpRequest)
			{/*** code for IE7+, Firefox, Chrome, Opera, Safari ***/
				xhttp=new XMLHttpRequest();
			}
			else
			{/*** code for IE6, IE5 ***/
				xhttp=new ActiveXObject("Microsoft.XMLHTTP");
			}
			
			xhttp.parent = this;
	
			xhttp.onreadystatechange=function()
			{
				/*** Append the Page Results to the Document: ***/
				if (xhttp.readyState==4 && xhttp.status==200)
				{
					try{
						var returnString = xhttp.responseText;
						
						console.log("Load Quiz Data:"+returnString);
						
						quizValues = eval ("(" + returnString + ")");
						
						console.log(quizValues["question_text"]);
						
						this.parent.id = questionID;
						this.parent.correct = quizValues["correct"];
						this.parent.questionType = quizValues["question_type"];
						this.parent.slide_ref_id = quizValues["slide_ref_id"];
												
						this.parent.Question = quizValues["question_text"];
						
						this.parent.dist = [];
						this.parent.dist[0] = quizValues["dist1"];
						this.parent.dist[1] = quizValues["dist2"];
						this.parent.dist[2] = quizValues["dist3"];
						this.parent.dist[3] = quizValues["dist4"];
						
						this.parent.resp_true =  quizValues["correct_response"];
						this.parent.resp_false =  quizValues["incorrect_response"];
						
						console.log("question loded from DB");
						
						/* DISPLAY THE QUIZ INTO THE ELEMENTS - THIS SHOULD MAYBE BE MOVED BUT WAS PLACED HERE DUE TO DB ASYNC TIMING: */
				
						questionDisplay(this.parent);
						
					}catch(e) {
						console.log("There was an error: "+e);
					}						
				}
				else {
					console.log("Not ready...."+xhttp.readyState+" Status: "+xhttp.status);
				}
			}
			
			console.log("Lang:"+user_language);
			
			var parameters="question_id="+ questionID;
			parameters +="&course="+ course.course_abv_english;
			if (user_language!=default_language && course.multilanguage != "1") parameters +="&language="+ user_language;
			console.log("Params: "+parameters);
			xhttp.open("POST","../course_data/getQuestionData.asp",false);
			xhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded")
			xhttp.send(parameters);	
		}
		else{
			console.log("** Loading Quiz: "+questionID+" ** v2-SCORM");
			
			var quizFile = "quiz_questions.xml";
			var fileTypeSplit = quizFile.lastIndexOf("."); 
			if (fileTypeSplit != -1 && user_language!=default_language && course.multilanguage != "1") quizFile = quizFile.substr(0, fileTypeSplit) + "_"+user_language+"."+ quizFile.substr(fileTypeSplit + 1);
						
			var xml = loadXMLDoc("quiz/"+quizFile);
			
			console.log(xml);
			console.log(xml.getElementsByTagName("question")[0]);
			console.log(xml.getElementsByTagName("question").length);
			
			/* FIND THE QUESTION NODE BY LOOPING THROUGH ALL QUESTIONS AND FINDING THE INDEX OF THE QUESTION WITH THE MATCHING ID: */
			var nodeNum;
			var question_node = undefined;
			var i = 0;
			while ((nodeNum==undefined)&&(i<xml.getElementsByTagName("question").length))
			{
				if (questionID === xml.getElementsByTagName("question")[i].getElementsByTagName("id")[0].childNodes[0].nodeValue){
					/*** store the XML information pertaining to the current quiz question ***/
					nodeNum=i;
					console.log("question found: "+questionID + " node: "+i);
					question_node = xml.getElementsByTagName("question")[nodeNum];
					
				}
				else {
					i++;
					console.log("not the right question....")
				}
			}
			
			console.log("Node Number: "+nodeNum);
			
			if (nodeNum!=undefined) {
				console.log("setting question data");
				
				this.id = questionID;
				this.correct = question_node.getElementsByTagName("correct")[0].childNodes[0].nodeValue;
				this.questionType = question_node.getElementsByTagName("question_type")[0].childNodes[0].nodeValue;
				this.slide_ref_id = question_node.getElementsByTagName("slide_ref_id")[0].childNodes[0].nodeValue;
				
				this.Question = question_node.getElementsByTagName("question_text")[0].childNodes[0].nodeValue;
				this.dist[0] = question_node.getElementsByTagName("dist1")[0].childNodes[0].nodeValue;
				this.dist[1] = question_node.getElementsByTagName("dist2")[0].childNodes[0].nodeValue;
				this.dist[2] = question_node.getElementsByTagName("dist3")[0].childNodes[0].nodeValue;
				this.dist[3] = question_node.getElementsByTagName("dist4")[0].childNodes[0].nodeValue;
				this.resp_true = question_node.getElementsByTagName("correct_response")[0].childNodes[0].nodeValue;
				this.resp_false = question_node.getElementsByTagName("incorrect_response")[0].childNodes[0].nodeValue;
				
				/* DISPLAY THE QUIZ INTO THE ELEMENTS - THIS SHOULD MAYBE BE MOVED BUT WAS PLACED HERE DUE TO DB ASYNC TIMING: */
				
				questionDisplay(this);
			}
			
			
			
		}
		
		

    };
}

/**************************************************
	End of Chapter Quiz OBJECT:
***************************************************/
function EOCQuiz() {
	this.returnedArray = []; //Stores the Returned array (Used for YOW Tracking)
	this.mixedArray = []; //Stores Quiz IDs in random order and length = Number of Questions to ask
	this.currentQuestion = 0; //The current question for the EOC to ask.
	this.eocChapter; //The chapter this Quiz is for
	
	this.quizResults; //Stores Each Questions answer and if it was correct or incorrect
	
	this.loadData = function(currentChapter) {
		this.eocChapter = currentChapter;
		
		if(course.tracking == "DB") {
			console.log("** Loading EOC: Chapter "+currentChapter+ " ** - DB");
			
			var eocValues = new Array(); 
			
			var xhttp;  

			if (window.XMLHttpRequest)
			{/*** code for IE7+, Firefox, Chrome, Opera, Safari ***/
				xhttp=new XMLHttpRequest();
			}
			else
			{/*** code for IE6, IE5 ***/
				xhttp=new ActiveXObject("Microsoft.XMLHTTP");
			}
			xhttp.parent = this;
			xhttp.onreadystatechange=function()
			{
				/*** Append the Page Results to the Document: ***/
				if (xhttp.readyState==4 && xhttp.status==200)
				{
					var returnString = xhttp.responseText;
						
					console.log("Load Quiz Data:"+returnString);
						
					eocValues = eval ("(" + returnString + ")");
					
					/* SET QUESTIONS TO ASK: */
					questions_to_ask = eocValues["questions_to_ask"];
								
					/* BUILD A LIST OF EOC QUESTIONS? */
					this.parent.returnedArray = eocValues["question_string"].split("[||]");			
					this.parent.mixedArray = [];
					
					if (isNaN(questions_to_ask)) 
					{
						console.log("questions not number");
						questions_to_ask = this.parent.returnedArray.length;
					}
					
					/*** Create Randomized Questions Array: ***/
					var j = 0;
					this.parent.quizResults = [];
					for(i = 0; i<questions_to_ask; i++){
						
						do{
							j = Math.floor(Math.random() * this.parent.returnedArray.length);
							if(this.parent.returnedArray[j] != "x"){
								this.parent.mixedArray[i] = this.parent.returnedArray[j];
								this.parent.returnedArray[j] = "x";
								this.parent.quizResults[i] = [];
								this.parent.quizResults[i][0] = 0;
								this.parent.quizResults[i][1] = 0;
							}
						}while(this.parent.mixedArray[i] == undefined || this.parent.mixedArray[i] == null || this.parent.mixedArray[i] == "");
						console.log("question to ask = " + this.parent.mixedArray[i]);
					}	
					//console.log("questions to ask = " + questions_to_ask);
					//console.log("chapter = " + this.parent.eocChapter);
					//console.log("returnedArray = " + this.parent.returnedArray);
					//console.log("mixedArray = " + this.parent.mixedArray);
					
					displayEOCStart();
				} else {
					/* UPDATE TO ERROR PAGE? */
				}
			}
			
			var parameters="chapter="+ currentChapter;
			parameters +="&course="+ course.course_abv_english;
			parameters +="&course_version="+ user.course_version;
			xhttp.open("POST","../course_data/getEOCData.asp",false);
			xhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded")
			xhttp.send(parameters);	
		}
		else{
			courseMessage("** Loading EOC: Chapter "+currentChapter+ " ** - SCORM",3,1);
				
		
			/*** SCORM: BUILD THE EOC_QUIZ ARRAY FROM XML : ***/
			
			var quizFile = "quiz_questions.xml";
			var fileTypeSplit = quizFile.lastIndexOf("."); 
			if (fileTypeSplit != -1 && user_language!=default_language && course.multilanguage != "1") quizFile = quizFile.substr(0, fileTypeSplit) + "_"+user_language+"."+ quizFile.substr(fileTypeSplit + 1);
						
			var xml = loadXMLDoc("quiz/"+quizFile);
			
			//GET THE QUIZ NODE:
			var quizes = xml.getElementsByTagName("quiz");
			var quiz_node;
			courseMessage("Number of Quiz Nodes: "+quizes.length, 4);
			for ( i = 0; i<quizes.length; i++){
				courseMessage("Comparing #"+i+" Quiz ID:" +xml.getElementsByTagName("quiz")[i].getAttribute("id") +" to Chapter:"+currentChapter, 4);
				if(xml.getElementsByTagName("quiz")[i].getAttribute("id").toString()==currentChapter.toString()) {
					courseMessage("chapter matches.",5);
					quiz_node = xml.getElementsByTagName("quiz")[i];
				}
				else {
					courseMessage("chapter not equal",5);
				}
			}		
			questions_to_ask = quiz_node.getAttribute("eoc");
			courseMessage("EOC Quiz node found # questions: "+questions_to_ask,4)
			
			var module = currentChapter;
			var x = quiz_node.getElementsByTagName("question");
			var j = 0;
			courseMessage("Question Nodes: "+x,5);
			for ( i = 0; i<x.length; i++){	
				/*** make table of question to ask ***/		
					courseMessage("Is it an EOC question? "+x[i].getElementsByTagName("eoc")[0].childNodes[0].nodeValue.toLowerCase(),5,1);				
					if (x[i].getElementsByTagName("eoc")[0].childNodes[0].nodeValue.toLowerCase() == "true" || x[i].getElementsByTagName("eoc")[0].childNodes[0].nodeValue.toLowerCase() == "1"){
						this.returnedArray[j] = x[i].getElementsByTagName("id")[0].childNodes[0].nodeValue;
						courseMessage(this.returnedArray[j],5);
						j++;	
					}
					courseMessage("--------",5,0);	
			}
			
			
			
			if (isNaN(questions_to_ask)) 
			{
				courseMessage("questions not number",4);
				questions_to_ask = this.returnedArray.length;
			}
			
			/*** Create Randomized Questions Array: ***/
			var j = 0;
			this.quizResults = [];
			this.mixedArray = [];
			for(i = 0; i<questions_to_ask; i++){
				
				do{
					j = Math.floor(Math.random() * this.returnedArray.length);
					if(this.returnedArray[j] != "x"){
						this.mixedArray[i] = this.returnedArray[j];
						this.returnedArray[j] = "x";
						this.quizResults[i] = [];
						this.quizResults[i][0] = 0;
						this.quizResults[i][1] = 0;
					}
				}while(this.mixedArray[i] == undefined || this.mixedArray[i] == null || this.mixedArray[i] == "");
				courseMessage("question to ask = " + this.mixedArray[i],5);
			}	
			courseMessage("questions to ask = " + questions_to_ask,4);
			courseMessage("returnedArray = " + this.returnedArray,4);
			courseMessage("mixedArray = " + this.mixedArray,4);
			
			displayEOCStart();
			
			courseMessage("** END EOC SCORM **", 3,0);
		}
	}
	
		
}

/**************************************************
	QUIZ FUNCTIONS
***************************************************/

var answerIndex = -1;


/*** LOAD THE QUESTION DIVS: ***/
function loadQuestionDivs(){
	
	/* RESET SELECTED INDEX: */
	answerIndex = -1;

	/*** ADD THE QUIZ QUESTION ELEMENTS: ***/
	document.getElementById('slideWindow').innerHTML =  "<div id='quiz'>";
	hideSlideBevel();
	document.getElementById('quiz').innerHTML +=  "<div id='divQuizQuestion' class='divQuizQuestion' > <span>Quiz Questions</span></div>";
	
	document.getElementById('quiz').innerHTML +=  "<div id='divQuizDistractor0' class='divQuizDistractor' >"
			+ "<div id='divQuizLetter0' class='divQuizLetter' tabIndex='3'>A.</div>"
			+ "<div id='divQuestion0' class='divQuestionButton'><span>Questions 01</span></div>"
			+ "</div>";
	
	document.getElementById('quiz').innerHTML +=  "<div id='divQuizDistractor1' class='divQuizDistractor' >"
			+ "<div id='divQuizLetter1' class='divQuizLetter'  tabIndex='3'>B.</div>"
			+ "<div id='divQuestion1' class='divQuestionButton'><span>Questions 02</span></div>"
			+ "</div>";
	
	document.getElementById('quiz').innerHTML +=  "<div id='divQuizDistractor2' class='divQuizDistractor' >"
			+ "<div id='divQuizLetter2' class='divQuizLetter'  tabIndex='3'>C.</div>"
			+ "<div id='divQuestion2' class='divQuestionButton'><span>Questions 03</span></div>"
			+ "</div>";
	
	document.getElementById('quiz').innerHTML +=  "<div id='divQuizDistractor3' class='divQuizDistractor' >"
			+ "<div id='divQuizLetter3' class='divQuizLetter'  tabIndex='3'>D.</div>"
			+ "<div id='divQuestion3' class='divQuestionButton'><span>Questions 04</span></div>"
			+ "</div>";
	
		
	document.getElementById('quiz').innerHTML +=  "<div id='submitAnswer' class='divQuizSubmit' tabIndex='4'>Submit</div>";
	if (user_language == "FRENCH"){
		document.getElementById('submitAnswer').innerHTML =  "Soumettre";
		
	}
	document.getElementById('slideWindow').innerHTML += "</div>";


}



/*** POPULATE QUESTION DIVS WITH QUESTION DATA: ***/
function questionDisplay(qObj){
	console.log("Displaying Question Data: "+qObj.Question);
	document.getElementById("divQuizQuestion").innerHTML = "<div>" + qObj.Question + "</div>";


	//POPUP FOR SLIDE REFERENCE SECTION START
	if (slideXml != undefined && qObj.EOCQuestion === true && course.showSlideReference == 1) {
		// create the popup object to display and then load the XML with the module index
		var slidePopupManager = new SlidePopupManager();
		console.log("slide_ref_id=" + qObj.slide_ref_id);
		slidePopupManager.loadSlideReference(slideXml, qObj.slide_ref_id);

		if (qObj.slide_ref_id != null) {
			var openLabel; user_language == "FRENCH" ? openLabel = "Ouvrir la diapositive" : openLabel = "Open Slide";
			document.getElementById('slideWindow').innerHTML += "<div id='btnOpenSlideRef' class='divQuizSubmit' style='position:absolute;left:3%;display:block;width:auto;'>" + openLabel + "</div>";
			document.getElementById('btnOpenSlideRef').addEventListener("click", function () {
				slidePopupManager.displaySlidePopup();
			})
		}
	}
	//POPUP FOR SLIDE REFERENCE SECTION END



	if(qObj.questionType == "true_or_false"){
		/*** SHOW A & B DISTRACTORS (TRUE/FALSE) ***/
		document.getElementById("divQuestion0").innerHTML = qObj.dist[0];
		document.getElementById("divQuestion1").innerHTML = qObj.dist[1];
		
		document.getElementById("divQuestion2").innerHTML = "";			//set txt to nothing
		document.getElementById("divQuestion3").innerHTML = "";			//set txt to nothing
		document.getElementById("divQuizDistractor2").style.display = "none"; //Hide the distractors
		document.getElementById("divQuizDistractor3").style.display = "none"; //Hide the distractors
	}
	else if (qObj.questionType == "multiple_choice"){
		for(i = 0; i <4; i++){
			/*** POPULATE THE DISTRACTOR DIV WITH THE TEXT: ***/
			document.getElementById("divQuestion"+i).innerHTML = qObj.dist[i];
		}
	}
	else if (qObj.questionType ==  "image_question"){
		for(i = 0; i <4; i++){
			/*** CHANGE THE DISTRACTOR ELEMENT TYPES TO IMAGE ***/
			var path = "quiz/quiz_img/" + qObj.dist[i].toUpperCase();
			path += ".jpg";
			document.getElementById("divQuizDistractor"+i).className = "divImageQuestion";	
			document.getElementById("divQuestion"+i).style.display = "none";	
			/*** SET THE BACKGROUND IMAGE TO THE IMAGE NAME STORED IN THE DISTRACTOR FIELD: ***/
			document.getElementById("divQuizDistractor"+i).style.backgroundImage = "url("+path+")";
			document.getElementById("divQuizDistractor"+i).style.backgroundRepeat = "no-repeat";			
			document.getElementById("divQuizDistractor"+i).style.backgroundSize = "100% 100%";
		}
	}
	/*** Add Click Response Event to Each Question Answer: ***/
	for(i = 0; i < 4; i++){
		/*document.getElementById("divQuizDistractor"+i).setAttribute("onclick",  "answerQuestion('"+qObj.id+"', "+i+"); return false;");*/
		document.getElementById("divQuizDistractor"+i).onclick = function (e) {
			selectAnswer(e);
		}
    }
	
	/* ADD CLICK RESPONSE TO SUBMIT BUTTON: */
	document.getElementById("submitAnswer").onclick = function (e) {

		//Hide the Open Slide reference button when answering if it exists
		if (document.getElementById("btnOpenSlideRef") != undefined) {
			document.getElementById("btnOpenSlideRef").style.display = "none";
		}

		answerQuestion(qObj);
	}
	
	/* TEMPORARY WORKAROUND WHILE QUESTIONS DONT EXIST.... */
	if (qObj.Question=="") {
		//console.log("enabling button");
		document.getElementById("nextButton").disabled = false;
		nextDisabled = false;
	}
}

function selectAnswer(e) {	
	/* SET THE ANSWER INDEX: */
	for(i = 0; i<4; i++) {			
		if((document.getElementById(e.target.id).id === "divQuestion"+i) || (document.getElementById(e.target.id).id === "divQuizLetter"+i) || (document.getElementById(e.target.id).id === "divQuizDistractor"+i)) 
		{
			answerIndex = i;
		}
		
		document.getElementById("divQuestion"+i).style.backgroundColor = "#AEC7FF";	
		document.getElementById("divQuestion"+i).style.border = "1px solid #31639C";
		document.getElementById("divQuestion"+i).style.color = "#003D79";	
		
		document.getElementById("divQuizLetter"+i).style.backgroundColor = "#AEC7FF";	
		document.getElementById("divQuizLetter"+i).style.border = "1px solid #31639C";
		document.getElementById("divQuizLetter"+i).style.color = "#003D79";		
	}	
	
	/* SELECT/HIGHLIGHT THE SELECTED ANSWER */
	document.getElementById("divQuestion"+answerIndex).style.backgroundColor = "#31639C";	
	document.getElementById("divQuestion"+answerIndex).style.border = "1px solid #FFF";
	document.getElementById("divQuestion"+answerIndex).style.color = "#FFF";	
	
	document.getElementById("divQuizLetter"+answerIndex).style.backgroundColor = "#31639C";	
	document.getElementById("divQuizLetter"+answerIndex).style.border = "1px solid #FFF";
	document.getElementById("divQuizLetter"+answerIndex).style.color = "#FFF";	
		
	/* SHOW THE SUBMIT BUTTON: */
	document.getElementById("submitAnswer").style.display = "block";
	document.getElementById("submitAnswer").focus();
}

/*** PROCESS ANSWER CLICK: ***/
function answerQuestion(qObj){
	
	
	console.log("Answer Click"+qObj.id);
	console.log(answerIndex);
	
		
	try{
		/*** FIND THE INDEX OF THE BUTTON CLICKED: ***/
		//var answerIndex = -1;
		
	
		
		//for(i = 0; i<4; i++) {
			
		//	if((document.getElementById(e.target.id).id === "divQuestion"+i) || (document.getElementById(e.target.id).id === "divQuizLetter"+i) || (document.getElementById(e.target.id).id === "divQuizDistractor"+i)) 
		//	{
		//		answerIndex = i;
		//	}
		//}
		
		/*** CLEAR THE QUESTION DIV AND ADD THE RESPONSE DIVS: ***/
		document.getElementById('quiz').innerHTML = '';				
		document.getElementById('quiz').innerHTML +=  "<div id='divQuestionHeader' class='divQuestionHeader'></div>";
		document.getElementById('quiz').innerHTML +=  "<div id='divQuestionResponse' class='divQuestionResponse'></div>";
		document.getElementById('quiz').innerHTML +=  "<div id='divQuestionNext' class='divQuestionNext'  tabIndex='3'></div>";
		
		
				
		if (answerIndex+1 == qObj.correct)
		{
			/*** SHOW THE RESPONSE TEXT: ***/
			document.getElementById('divQuestionResponse').innerHTML += qObj.resp_true;
			
			/*** SHOW CORRECT! HEADER DIV: ***/
			document.getElementById('divQuestionHeader').innerHTML = "<span class='lQuestionCorrect'>Correct</span>!";	
			document.getElementById('divQuestionHeader').style.color = "#009933";
								
			/*** LOAD & PLAY 'CORRECT' AUDIO: ***/
			
			/*** ENABLE NEXT BUTTON: ***/
			document.getElementById("nextButton").disabled = false;
			
			/*** SHOW CONTINUE BUTTON ***/
			document.getElementById('divQuestionNext').innerHTML = "<span class='lQuestionButtonContinue'>Continue</span>";						
			document.getElementById('divQuestionNext').setAttribute("onclick", document.getElementById("nextButton").getAttribute("onclick"));
		}
		else
		{	
			/*** SHOW THE RESPONSE TEXT: ***/			
			document.getElementById('divQuestionResponse').innerHTML += qObj.resp_false;
			
			/*** SHOW INCORRECT! HEADER DIV: ***/
			document.getElementById('divQuestionHeader').innerHTML = "<span class='lQuestionIncorrect'>Incorrect</span>!";
			document.getElementById('divQuestionHeader').style.color = "red";
			
			/*** LOAD & PLAY 'INCORRECT' AUDIO: ***/
			
			/*** SHOW TRY AGAIN BUTTON: ***/
			document.getElementById('divQuestionNext').innerHTML = "<span class='lQuestionButtonTryAgain'>Try Again</span>";
			document.getElementById('divQuestionNext').onclick = function () {
				loadQuestionDivs(); 
				questionDisplay(qObj);
			}
		}
				
		/*** IF THIS EOC THEN SHOW NEXT BUTTON: ***/
		if (qObj.EOCQuestion === true)
		{
			/*
			printToConsole(eocQuizObj);
			*/
			
			/*
			IF DB TRACKING SUBMIT THE QUESTION ANSWER TO THE DATABASE (IF FIRST QUESTION SEND CLEAR):
			*/
			if(course.tracking == "DB") {
				console.log("** Saving EOC Answer ** - DB");
				
				var returnValues = new Array(); 
				
				var xhttp;  
	
				if (window.XMLHttpRequest)
				{/*** code for IE7+, Firefox, Chrome, Opera, Safari ***/
					xhttp=new XMLHttpRequest();
				}
				else
				{/*** code for IE6, IE5 ***/
					xhttp=new ActiveXObject("Microsoft.XMLHTTP");
				}
				xhttp.parent = this;
				xhttp.onreadystatechange=function()
				{
					/*** Append the Page Results to the Document: ***/
					if (xhttp.readyState==4 && xhttp.status==200)
					{
						var returnString = xhttp.responseText;
							
						console.log("Save Data:"+returnString);
							
						returnValues = eval ("(" + returnString + ")");
						
						//var tempVar = returnValues["var_name"];
									
						
					} else {
						/* UPDATE TO ERROR PAGE? */
					}
				}
				
				console.log("Current Question sent to ASP:"+eocQuizObj.currentQuestion);
				
				var parameters="cbtusername="+ user.username;
				parameters +="&chapter="+ eocQuizObj.eocChapter;
				parameters +="&question_id="+ qObj.id;
				parameters +="&selection="+ (answerIndex+1);
				parameters +="&current_question="+ (eocQuizObj.currentQuestion-1);
				xhttp.open("POST","../course_data/setEOCAnswer.asp",false);
				xhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded")
				xhttp.send(parameters);	
			}
			
			
			if(answerIndex+1 == qObj.correct) 
			{
				eocQuizObj.quizResults[eocQuizObj.currentQuestion-1][1] = 1;
			}
			
			eocQuizObj.quizResults[eocQuizObj.currentQuestion-1][0] = answerIndex;
								
			/*** SHOW THE NEXT BUTTON: ***/
			document.getElementById('divQuestionNext').innerHTML = "<span class='lQuestionButtonNext'>Next</span>";		
			
			/*** CHECK TO SEE IF THE USER ANSWERED ALL QUESTIONS: ***/						
			if(eocQuizObj.currentQuestion >= eocQuizObj.mixedArray.length)
			{
			
				/*** NEXT BUTTON - ONCLICK SHOWS QUIZ RESULTS: ***/
				document.getElementById('divQuestionNext').onclick = function () {
					eocCalculateResults();					
				}
			}
			else
			{
				/*** LOAD THE NEXT QUESTION: ***/
				document.getElementById('divQuestionNext').onclick = function () {
					loadQuestionDivs();
					
					var nextQuestion = new Question();
					nextQuestion.EOCQuestion = true;
					
					nextQuestion.loadData(eocQuizObj.mixedArray[eocQuizObj.currentQuestion]);
					
					eocQuizObj.currentQuestion++; //INCREASE THE CURRENT QUESTION TO NEXT QUESTION.
		
					
					//questionDisplay(nextQuestion);
				}
				
			}
		}
		
		document.getElementById('divQuestionNext').focus();
		
		/*** CONVERT TEXT TO THE SELECTED LANG: ***/
		change_text_language("EOC.xml");					
	
	}catch(err){
		console.log("*** ERROR!***\n"+err);
	} 	
}

function eocCalculateResults() {
	if(course.tracking == "DB") {
		console.log("** Saving EOC Answer ** - DB");
		
		var returnValues = new Array(); 
		
		var xhttp;  
	
		if (window.XMLHttpRequest)
		{/*** code for IE7+, Firefox, Chrome, Opera, Safari ***/
			xhttp=new XMLHttpRequest();
		}
		else
		{/*** code for IE6, IE5 ***/
			xhttp=new ActiveXObject("Microsoft.XMLHTTP");
		}
		xhttp.parent = this;
		xhttp.onreadystatechange=function()
		{
			/*** Append the Page Results to the Document: ***/
			if (xhttp.readyState==4 && xhttp.status==200)
			{
				var returnString = xhttp.responseText;
					
				console.log("Save Data:"+returnString);
					
				returnValues = eval ("(" + returnString + ")");
				
				//var tempVar = returnValues["var_name"];
				var numCorrect = returnValues["numCorrect"];
				var questionsAsked = returnValues["questionsAsked"];
				user.quizArray[eocQuizObj.eocChapter-1][0] = returnValues["score"];
				user.quizArray[eocQuizObj.eocChapter-1][1] = returnValues["attempts"];
				
				console.log("numCorrect: "+numCorrect);
				console.log("questionsAsked: "+questionsAsked);
				console.log("Score: "+user.quizArray[eocQuizObj.eocChapter-1][0]);
				console.log("Attempts: "+user.quizArray[eocQuizObj.eocChapter-1][1]);
				
				eocDisplayResults(numCorrect);
							
				
			} else {
				/* UPDATE TO ERROR PAGE? */
			}
		}
		
		console.log("Current Question sent to ASP:"+eocQuizObj.currentQuestion);
		
		var parameters="cbtusername="+ user.username;
		parameters +="&chapter="+ eocQuizObj.eocChapter;
		parameters +="&course="+ course.course_abv_english;		
		parameters +="&course_version="+ user.course_version;
		xhttp.open("POST","../course_data/setEOCData.asp",false);
		xhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xhttp.send(parameters);	
	} else {
								
		var numCorrect = 0;
		var questionsAsked = "";
	
		for(i = 0; i<eocQuizObj.mixedArray.length; i++)
		{
			if (eocQuizObj.quizResults[i][1] === 1) 
			{
				numCorrect++;
			}
			
			/*** BUILD THE QUESTIONSANSWERED STRING TO SAVE IN YOW DB: ***/
			if(questionsAsked !="") 
			{
				questionsAsked += ",";
			}
			
			questionsAsked += eocQuizObj.mixedArray[i]+"-"+eocQuizObj.quizResults[i][1] +"-"+(eocQuizObj.quizResults[i][0]+1);
		}
		
		/*** SET THE SCORE AND ATTEMPTS IN USER OBJECT AND STORE THE DATA ***/
		user.quizArray[eocQuizObj.eocChapter-1][0] = Math.round((numCorrect/eocQuizObj.mixedArray.length)*100);
		console.log("attempts: " +user.quizArray[eocQuizObj.eocChapter-1][1]);
		if (parseInt(user.quizArray[eocQuizObj.eocChapter-1][1]) != 'NaN')
		{
		
			user.quizArray[eocQuizObj.eocChapter-1][1] = parseInt(user.quizArray[eocQuizObj.eocChapter-1][1])+1;	
		}
		else 
		{
			user.quizArray[eocQuizObj.eocChapter-1][1] = 1;
		}
		console.log("attempts: " +user.quizArray[eocQuizObj.eocChapter-1][1])
		
		setQuizValue(eocQuizObj.eocChapter, user.quizArray[eocQuizObj.eocChapter-1][0], user.quizArray[eocQuizObj.eocChapter-1][1], questionsAsked);
		
		eocDisplayResults(numCorrect);
	}
	
}

/*** DISPLAY THE EOC QUIZ RESULTS, RECORD THE SCORE ***/
function eocDisplayResults(f_numCorrect)
{
	document.getElementById('slideWindow').innerHTML = "<h1 style='text-align: center;'><span class='lEOCResultsTitle'>Quiz Results</span></h1>";
	
	/*** SHOW THE RESULTS TABLE: ***/						
	var resultTblTxt = "<br/><table class='eocResultsTbl'>";
	resultTblTxt += "<tr><td class='right'><span class='lEOCResultsTotal'>Total Questions</span>: </td><td><b>" +eocQuizObj.mixedArray.length+ "</b></td></tr>";
	resultTblTxt += "<tr><td class='right'><span class='lEOCResultsCorrect'>Number of Correct Answers</span>: </td><td><b>" +f_numCorrect+ "</b></td></tr>";
	resultTblTxt += "<tr><td class='right'><span class='lEOCResultsIncorrect'>Number of Incorrect Answers</span>: </td><td><b>" +(eocQuizObj.mixedArray.length-f_numCorrect)+ "</b></td></tr>";
	resultTblTxt += "<tr><td class='right'><span class='lEOCResultsScore'>Quiz Score</span>: </td><td id='eocFinalScore'><b>" +Math.round((f_numCorrect/eocQuizObj.mixedArray.length)*100)+ "%</b></td></tr>";
	resultTblTxt += "</table>";
	document.getElementById('slideWindow').innerHTML += resultTblTxt;
											
	/*** IF FAILED THEN SHOW THE PERCENTAGE REQUIRED TO PASS ***/
	if (Math.round((f_numCorrect/eocQuizObj.mixedArray.length)*100) >= user.quizThresh)
	{
		document.getElementById('eocFinalScore').style.color = "#006600";
		document.getElementById('slideWindow').innerHTML += "<h2 style='text-align: center; color: #006600;'><span class='lEOCResultsPassed'>Congratulations!  You have passed this quiz</span>.</h2>";
		document.getElementById('slideWindow').innerHTML += "<p style='text-align: center;'><span class='lEOCResultsRecorded'>Your Quiz results have been recorded</span>.</p>";
		
	}
	else
	{
		document.getElementById('eocFinalScore').style.color = "red";
		document.getElementById('slideWindow').innerHTML += "<h2 style='text-align: center; color: red;'><span class='lEOCResultsfailed'>Sorry, you have not passed this quiz</span>.</h2>";
		document.getElementById('slideWindow').innerHTML += "<p style='text-align: center;'><span class='lEOCResultsFail2'>You need to score above</span> "+user.quizThresh+"% <span class='lEOCResultsFail3'>in order to pass the quiz</span>.</p>";
		document.getElementById('slideWindow').innerHTML += "<p style='text-align: center;'><span class='lEOCResultsFailContinue'>Continue to the Course Outline to retake this chapter</span>.</p>";
	}

	/*** ADD CONTINUE BUTTON ***/						
	document.getElementById('slideWindow').innerHTML += "<div id='EOCEndButton' class='divQuestionNext'><span class='lEOCResultsContinue'>Continue</span></div>";	
	document.getElementById("EOCEndButton").onclick = function () {
		if(getQueryVariable("cbtusername") == "demo_user"){
			demo_complete(); 			
		} else {
			window.location = "main.html?cbtusername="+user.username+'&lang='+user_language;
		}
	}
	document.getElementById("EOCEndButton").focus();
		
	/*** CONVERT TEXT TO THE SELECTED LANG: ***/
	change_text_language("EOC.xml");
}
