﻿var oldAddAsset = addAsset;
var oldStage = stage;

class Slide {
    constructor() {
		this.id = null;
		this.type = null;
		this.title = null;
		this.imageUrl = null;
		this.audioSrc = null;
		this.narration = null;
		this.slideReferenceId = null;
		this.slideFileName = null;
		this.advancedFileHtml = null;
    }
}

class SlideXml {
	constructor() {
		this.xmlDoc = null;
		this.chapterNumber = null;
		this.assetURL = null;

		//error message to be appended somewhere(narration?)
		this.narration_text
	}

	//open the Xml Sco file into xmlDoc property
	openXmlSco(chapNum, chapterArray, chapterArrayPoss) {
		this.chapterNumber = chapNum;

		var pageNode;
		this.assetURL = "";

		//check to see if not a client custom page
		if (chapterArray[chapterArrayPoss][2] == 0) {
			
			try {
				if (xmlDoc == null) {
					var xmlDoc;
				}
				//read the xml file
				xmlDoc = loadXMLDoc("chapter" + chapNum + "_sco.xml");

			}
			catch (err) {
				courseMessage(err, 1);
			}

			pageNode = chapterArray[chapterArrayPoss][1];
		}
		else {
			
			try {
				if (xmlDoc == null) {
					var xmlDoc;
				}
				//read the xml file
				xmlDoc = loadXMLDoc(global.courseCutomizationPath + user.adminID + "/" + course.course_abv_english + "/chapter" + chapNum + "_sco.xml");
				pageNode = chapterArray[chapterArrayPoss][1];
				this.assetURL = global.courseCutomizationPath + user.adminID + "/" + course.course_abv_english + "/";
			}
			catch (err) {
				courseMessage(err, 1);
			}

		}

		this.xmlDoc = xmlDoc;

	}

	//not needed?
	//loop all slides until we find the matching slideId, then return its index
	findSlideIndex(slideId) {
		var slideList = this.xmlDoc.getElementsByTagName("page");
		for (var i = 0; i < slideList.length; i++) {
			var loopedSlideId = slideList[i].getAttribute("id");
			if (loopedSlideId == slideId) {
				return i;
			}
        }
	}

	//create a slide object based on a slideId and then return it
	//Xml document array are also acting like dictionairy/maps with key.
	//slideId can be an integer representing an index(0) or a string representing a key(M2_P1)
	getSlide(slideId) {

		var slide = new Slide();

		try {
			if (!this.isValidSlide(slideId)) {
				throw new Error('Not a valid slideId: ' + slideId);
			}
        
			slide.id = this.loadSlideId(slideId);
			slide.type = this.LoadSlideType(slideId);
			slide.slideReferenceId = this.loadSlideReferenceId(slideId);
			slide.title = this.loadSlideTitle(slideId);
			slide.audioSrc = this.loadAudio(slideId);
			slide.narration = this.loadNarrationText(slideId);
			slide.slideFileName = this.getSlideName(slideId);

			if (slide.type == "advanced") {
				slide.advancedFileHtml = this.loadAdvancedSlideHtml(slide.slideFileName);
			} else if (slide.type == "standard") {
				slide.imageUrl = this.loadSlideImage(slide.slideFileName);
			} else if (slide.type == "quiz") {
				//do not use slideFileName for quizzes
			}
		}
		catch (e) {
			courseMessage(e, 1, 0);
		}

		return slide;
	}

	isValidSlide(slideId) {
		return this.xmlDoc.getElementsByTagName("page")[slideId] != null;
	}

	loadSlideId(slideId) {
		return this.xmlDoc.getElementsByTagName("page")[slideId].getAttribute("id");
	}

	LoadSlideType(slideId) {
		return this.xmlDoc.getElementsByTagName("page")[slideId].getAttribute("type");
	}

	loadSlideReferenceId(slideId) {
		if (this.xmlDoc.getElementsByTagName("page")[slideId].getElementsByTagName("slideref")[0] != undefined) {
			return this.xmlDoc.getElementsByTagName("page")[slideId].getElementsByTagName("slideref")[0].childNodes[0].nodeValue;
		}
	}

	loadNarrationText(slideId) {
		var narration_text;
		if (this.xmlDoc.getElementsByTagName("page")[slideId].getElementsByTagName("narration")[0].getElementsByTagName(user_language)[0] !== undefined) {
			narration_text = this.xmlDoc.getElementsByTagName("page")[slideId].getElementsByTagName("narration")[0].getElementsByTagName(user_language)[0].childNodes[0].nodeValue;
		} else {
			if (this.xmlDoc.getElementsByTagName("page")[slideId].getElementsByTagName("narration")[0].getElementsByTagName(default_language)[0] !== undefined) {
				narration_text = this.xmlDoc.getElementsByTagName("page")[slideId].getElementsByTagName("narration")[0].getElementsByTagName(default_language)[0].childNodes[0].nodeValue;
			} else {
				narration_text = this.xmlDoc.getElementsByTagName("page")[slideId].getElementsByTagName("narration")[0].childNodes[0].nodeValue;
			}
		}

		return narration_text;
	}

	loadSlideTitle(slideId) {
		var slideTitle;
		if (this.xmlDoc.getElementsByTagName("page")[slideId].getElementsByTagName("title")[0].getElementsByTagName(user_language)[0] !== undefined) {
			slideTitle = this.xmlDoc.getElementsByTagName("page")[slideId].getElementsByTagName("title")[0].getElementsByTagName(user_language)[0].childNodes[0].nodeValue;
		} else {
			if (this.xmlDoc.getElementsByTagName("page")[slideId].getElementsByTagName("title")[0].getElementsByTagName(default_language)[0] !== undefined) {
				slideTitle = this.xmlDoc.getElementsByTagName("page")[slideId].getElementsByTagName("title")[0].getElementsByTagName(default_language)[0].childNodes[0].nodeValue;
			} else {
				slideTitle = this.xmlDoc.getElementsByTagName("page")[slideId].getElementsByTagName("title")[0].childNodes[0].nodeValue;
			}
		}

		return slideTitle;
	}

	getSlideName(slideId) {
		var slideName = this.xmlDoc.getElementsByTagName("page")[slideId].getElementsByTagName("slide")[0].childNodes[0].nodeValue;
		
		var fileTypeSplit = slideName.lastIndexOf(".");

		var fileMultilingual = this.xmlDoc.getElementsByTagName("page")[slideId].getElementsByTagName("slide")[0].getAttribute("multilingual");
		if (fileTypeSplit != -1 && user_language != default_language && fileMultilingual == 1 && course.multilanguage != "1") slideName = slideName.substr(0, fileTypeSplit) + "_" + user_language + "." + slideName.substr(fileTypeSplit + 1);

		return slideName;
	}

	loadSlideImage(slide_file) {

		var image_src = this.assetURL + "module_" + this.chapterNumber + "/images/" + slide_file;
		if (!fileExists(image_src)) {
			image_src = this.assetURL + global.courseFilesPath + "images/img_not_found.jpg";
		}

		return image_src;
	}

	loadAdvancedSlideHtml(slide_file) {

		var htmlContents;
		var fileCompleteName = this.assetURL + "module_" + this.chapterNumber + "/" + slide_file
		
		if (fileExists(fileCompleteName)) {
			htmlContents = loadTextFile(fileCompleteName);
		} else {
			htmlContents = "";
		}

		return htmlContents;
	}

	loadAudio(pageNode) {
		var audio_src;
		var audioFile;
		var audio_node = this.xmlDoc.getElementsByTagName("page")[pageNode].getElementsByTagName("audio")[0];
		
		if (audio_node.childNodes[0] != undefined) {
			audioFile = audio_node.childNodes[0].nodeValue;
		}
		//console.log("audioFile" + audioFile);
		if (audioFile) {
			var fileTypeSplit = audioFile.lastIndexOf(".");
			if (fileTypeSplit != -1 && user_language != default_language && course.multilanguage != "1") audioFile = audioFile.substr(0, fileTypeSplit) + "_" + user_language + "." + audioFile.substr(fileTypeSplit + 1);
			audio_src = this.assetURL + "module_" + this.chapterNumber + "/audio/" + audioFile;
		} else {
			audio_src = "";
		}

		return audio_src;
	}
}

class SlidePopupManager {
	
	constructor() {
		this.slideXml = null;
		this.slideReference = null;
		this.mySlidePlayer = null;
	}

	//slideReferenceId can be an integer representing an index(0) or a string representing a key(M2_P1)
	loadSlideReference(slideXml, slideReferenceId) {
		this.slideXml = slideXml;
		this.slideReference = this.slideXml.getSlide(slideReferenceId);
    }
	
	populateSlideReferencePopup() {
		this.createPlayer();

		//need to attach this before using eval when importing advanced slides
		this.mySlidePlayer.attachPlayerToHtmlTagId("slideReferencePopup");
		
		this.populateSlideNarration();
		this.populateSlideTitle();
		
		this.populateSlideContent();
		this.populateSlideAudio();
		
	}

	createPlayer() {
		this.mySlidePlayer = new SlidePlayer();
		this.mySlidePlayer.createSlidePlayer();
	}

	populateSlideNarration() {
		if (this.slideReference != null) {
			this.mySlidePlayer.setNarration(this.slideReference.narration);
		}
    }

	populateSlideTitle() {
		if (this.slideReference) {
			this.mySlidePlayer.setTitle(this.slideReference.title);
        }
	}

	populateSlideContent() {

		if (this.slideReference.type === "advanced") {

			//hide the image by default
			this.mySlidePlayer.hideContentImage();

			//image can be loaded in hijacked function addAsset if called from this.executeJavascript("slideJS");
			var parent = this;
			addAsset = function (id, src, type) {

				var imageSrc = src;
				if (!fileExists(imageSrc)) {
					imageSrc = parent.slideXml.assetURL + global.courseFilesPath + "images/img_not_found.jpg";
				}

				parent.mySlidePlayer.setContentImage(imageSrc);

				//addAsset was called so show the image
				parent.mySlidePlayer.showContentImage();

			}

			//html content should not be empty for advanced slides, also note that an image could be loaded by either an html img tag or an addAsset call
			var htmlContent = this.slideReference.advancedFileHtml;
			if (htmlContent == "") {
				imageSrc = parent.slideXml.assetURL + global.courseFilesPath + "images/img_not_found.jpg";
				parent.mySlidePlayer.setContentImage(imageSrc);
				parent.mySlidePlayer.showContentImage();
			}

			this.mySlidePlayer.setContentHtml(htmlContent);

			//slide JS must run after this.mySlidePlayer html controls have been added to the DOM
			this.executeJavascript("slideJS");

			//set back the addAsset function to its original form
			addAsset = oldAddAsset;

		}
		else {
			var imageSrc = this.slideReference.imageUrl;
			if (!fileExists(imageSrc)) {
				imageSrc = this.slideXml.assetURL + global.courseFilesPath + "images/img_not_found.jpg";
			}
			this.mySlidePlayer.setContentImage(imageSrc);
		}
	}

	populateSlideAudio() {
		var audio_src = this.slideReference.audioSrc ;
		
		if (fileExists(audio_src)) {

			//load the audio and don't use addAsset for now
			this.mySlidePlayer.setAudioSource(audio_src);
			
		} else {

			//Warning! This slide is missing the audio file.

			if (this.slideReference === "quiz") {

				//Quizes don't need a fallback audio message so don't play anything

			}
			else {

				//Play a default 6 seconds empty sound (long enought for the slide title to animate)
				audio_src = global.courseFilesPath + "audio/SILENCE_6_SEC.mp3"
				this.mySlidePlayer.setAudioSource(audio_src);

				// SHOW MISSING AUDIO FOR YOW USERS
				if ((user.company).toUpperCase() == "YOW TEST") {
					this.mySlidePlayer.addNarrationError("<span style='color: red;'>[<i>MISSING AUDIO</i>]</span><br><br>");
				}

			}
		}
		 
	}
	
	displaySlidePopup() {

		if (this.slideReference != null) {

			//create popup, and attach it to the DOM
			this.populateSlideReferencePopup();

			//hijack the stage default behaviour(because advanced slides using the addAsset method)
			oldStage = stage;
			stage = new createjs.Stage(this.mySlidePlayer.canvas.id);
			
			document.getElementById("mainOverlay").style.zIndex = 0;
			document.getElementById("mainOverlay").style.display = "block";
			//document.getElementById("MainMenuContent").style.display = "none";

			//start audio when showing the slide
			this.mySlidePlayer.show(true);
			this.mySlidePlayer.play();


			//add a close popup button function
			var myParent = this;
			this.mySlidePlayer.closeButton.onclick = function () {

				//reset the hijacked stage, should stage be unloaded first?
				stage = oldStage;

				document.getElementById("mainOverlay").style.display = "none";
				//document.getElementById("MainMenuContent").style.display = "block";

				//stop audio, then detach player from DOM
				myParent.mySlidePlayer.pause();
				myParent.mySlidePlayer.show(false);
				myParent.mySlidePlayer.removePlayerFromHtmlTagId();

				return false;
			};
		}

	}

	//utility function
	executeJavascript(elementIdString) {
		/*** EXECUTE THE INCLUDED JAVASCRIPT - PUT IN TRY CATCH INCASE SLIDE HAS NO JS: ***/
		try {
			if (elementIdString == "") { elementIdString = "slideJS"; }

			var slideJS = document.getElementById(elementIdString).innerHTML;
			jQuery.globalEval(slideJS);
		} catch (e) {
			courseMessage("There is no Slide JS: " + e, 1);
		}
	}


}

class SlidePlayer{
	constructor() {
		this.mainDiv = null;
		this.heightHelper = null;
		this.titleDiv = null;
		this.narrationDiv = null;
		this.narrationHtml = null;
		this.contentDiv = null;
		this.contentImageDiv = null;
		this.contentInsetShadow = null;
		this.contentHtmlDiv = null;
		this.canvas = null;
		this.mediaPlayer = null;
		this.audioSource = null;
		this.mediaPlayerControls = null;
		this.closeButton = null;
		this.reloadBtn = null;
		this.playPauseBtn = null;
		this.muteBtn = null;
		this.progressBar = null;
		this.volumeBar = null;
	}

	createSlidePlayer() {

		//#region InternalMethods

		function eventMediaPlayerTimeUpdate() {
			parent.progressBar.value = parent.mediaPlayer.currentTime / parent.mediaPlayer.duration * parent.progressBar.max;
		}

		function replayMedia() {
			resetPlayer();

			parent.mediaPlayer.play();

		}

		function resetPlayer() {
			//reset the progress bar to 0
			parent.progressBar.value = 0;

			parent.mediaPlayer.currentTime = 0;
		}

		function togglePlayPause() {
			//console.log("play event");
			if (this.mediaPlayer.paused) {
				this.mediaPlayer.play();
			} else {
				this.mediaPlayer.pause();
			}
		}

		function toggleMute() {
			//console.log("mute event");
			if (this.mediaPlayer.muted) {
				this.mediaPlayer.muted = false;
			} else {
				this.mediaPlayer.muted = true;
			}
		}




		//function SetProgress(positionX) {
		//	var parentPositionX = findPosX(positionX);
		//	var parentOffsetWidth = parent.progressBar.offsetWidth;
		//	var percent = positionX - parent.progressBar.offsetLeft / parentOffsetWidth;
		//	//var newPercent = Math.max(0, Math.min(1, (PositionX - findPosX(parent.progressBar)) / parent.progressBar.offsetWidth));
		//}

		//function setVolumeBar(clickedOnPageX) {
		//	//var clickedOnPageX = e.pageX
		//	var progressBarOnPageX = findPosX(parent.volumeBar);
		//	var progressBarWidth = parent.volumeBar.offsetWidth;
		//	var clickedOnProgressBarX = clickedOnPageX - progressBarOnPageX;
		//	//var progressBarMaxValue = this.max;
		//	var percent = clickedOnProgressBarX / progressBarWidth;

		//	return percent;
		//}
		//function setProgressBar(clickedOnPageX) {
		//	//var clickedOnPageX = e.pageX
		//	var progressBarOnPageX = findPosX(parent.progressBar);
		//	var progressBarWidth = parent.progressBar.offsetWidth;
		//	var clickedOnProgressBarX = clickedOnPageX - progressBarOnPageX;
		//	//var progressBarMaxValue = this.max;
		//	var percent = clickedOnProgressBarX / progressBarWidth;

		//	return percent;
		//}
		//function moveProgressBar(e) {
		//	var percent = setProgressBar(e.pageX);

		//	//visually set the current progress of the progressbar
		//	parent.progressBar.value = percent * parent.progressBar.max;

		//	console.log("parent.progressBar.value=" + parent.progressBar.value);
		//	//set the audio to match the progressbar position
		//	parent.mediaPlayer.currentTime = percent * parent.mediaPlayer.duration;
		//}
		//function moveVolumeBar(e) {

		//	var percent = setVolumeBar(e.pageX);

		//	//visually set the current progress of the progressbar
		//	parent.volumeBar.value = percent * parent.volumeBar.max;

		//	//set the audio to match the volumebar position
		//	parent.mediaPlayer.volume = percent;
		//}

		
		//get objects position on the page
		function findPosX(obj) {
			var curleft = obj.offsetLeft;
			//console.log(obj);
			//while obj is not null add the parents offset
			while (obj = obj.offsetParent) {
				curleft += obj.offsetLeft;
			}
			return curleft;
		}
		function setProgressbar(e) {

			var progressbar = e.currentTarget;

			var progressbarX = findPosX(progressbar);
			var progressbarWidth = progressbar.offsetWidth;
			var progressbarClickX = e.pageX - progressbarX;
			var percent = progressbarClickX / progressbarWidth;

			progressbar.value = percent * progressbar.max;

			progressbar.lastPercent = percent; //adding lastPercent property
		}

		function moveVolumebar(e) {

			setProgressbar(e);

			parent.mediaPlayer.volume = e.currentTarget.lastPercent;

		}

		function eventProgressbarMouseDown(e) {
			parent.mediaPlayer.pause();
			var progressbar = e.currentTarget;
			progressbar.addEventListener("mousemove", setProgressbar);
			setProgressbar(e);

			parent.mediaPlayer.currentTime = progressbar.lastPercent * parent.mediaPlayer.duration;

			//for not selecting all text when dragging the mouse cursor
			if (e.preventDefault) e.preventDefault();
		}
		function eventProgressbarMouseUp(e) {
			var progressbar = e.currentTarget;
			progressbar.removeEventListener("mousemove", setProgressbar);
			setProgressbar(e);

			parent.mediaPlayer.currentTime = progressbar.lastPercent * parent.mediaPlayer.duration;
			parent.mediaPlayer.play();
		}

		function eventVolumebarMouseDown(e) {
			var progressbar = e.currentTarget;
			progressbar.addEventListener("mousemove", moveVolumebar);
			moveVolumebar(e);
			//for not selecting all text when dragging the mouse cursor
			if (e.preventDefault) e.preventDefault();
		}
		function eventVolumebarMouseUp(e) {
			var progressbar = e.currentTarget;
			progressbar.removeEventListener("mousemove", moveVolumebar);
			moveVolumebar(e);
		}
		//#endregion InternalMethods

		var parent = this;

		this.mainDiv = document.createElement("div");
		this.mainDiv.id = "MediaPlayerMainId";
		this.mainDiv.className = "slidePopupContainer"
		this.heightHelper = document.createElement("div");
		this.heightHelper.id = "MediaPlayerHeightHelperId";
		this.heightHelper.className = ""; //heightHelper

		this.titleDiv = document.createElement("div");
		this.titleDiv.id = "MediaPlayerTitleId";
		this.titleDiv.className = "slidePopupTitle";

		this.narrationDiv = document.createElement("div");
		this.narrationDiv.id = "MediaPlayerNarrationId";
		this.narrationDiv.className = "slidePopupNarration";
		this.narrationHtml = document.createElement("div");
		this.narrationHtml.id = "MediaPlayerNarrationHtmlId";
		this.narrationHtml.className = "slidePopupNarrationContent";

		this.contentDiv = document.createElement("div");
		this.contentDiv.id = "MediaPlayerContentId";
		this.contentDiv.className = "slidePopupContentWindow";
		this.contentImageDiv = document.createElement("img");
		this.contentImageDiv.id = "MediaPlayerContentImageId";
		this.contentImageDiv.className = "slidePopupContentImage";
		
		this.contentInsetShadow = document.createElement("div");
		this.contentInsetShadow.id = "MediaPlayerContentInsetShadow";
		this.contentInsetShadow.className = "slidePopupContentInsetShadow";

		this.contentHtmlDiv = document.createElement("div");
		this.contentHtmlDiv.id = "MediaPlayerContentHtmlId";
		this.contentHtmlDiv.className = "";
		this.canvas = document.createElement("canvas");
		this.canvas.id = "MediaPlayerCanvas";
		this.canvas.width = "640";
		this.canvas.height = "480";
		this.canvas.className = "";
		this.canvas.style.backgroundColor = "transparent";
		this.canvas.style.width = "1320";
		this.canvas.style.height = "990";
		this.mediaPlayer = document.createElement("audio");
		this.mediaPlayer.id = "MediaPlayerAudio";
		this.mediaPlayer.className = "slidePopupTempControls";
		this.mediaPlayer.controls = false;
		this.mediaPlayer.addEventListener('play', function () { /*console.log("play new media player");*/ }, false);
		this.mediaPlayer.addEventListener('timeupdate', eventMediaPlayerTimeUpdate, false);

		this.audioSource = document.createElement("source");
		this.audioSource.id = "MediaPlayerAudioSource";

		this.mediaPlayerControls = document.createElement("div");
		this.mediaPlayerControls.id = "MediaPlayerControls";
		this.mediaPlayerControls.className = "mediaWrapper mediaControls"

		this.closeButton = document.createElement("div");
		this.closeButton.id = "MediaPlayerClose";
		this.closeButton.innerHTML = "X";
		this.closeButton.className = "popupButton slidePopupButton";
		
		this.reloadBtn = document.createElement("button");
		this.reloadBtn.id = "MediaPlayerReload";
		this.reloadBtn.innerHTML = "Reload";
		this.reloadBtn.className = "replay";
		this.reloadBtn.onclick = () => { replayMedia(); }

		this.playPauseBtn = document.createElement("button");
		this.playPauseBtn.id = "MediaPlayerPlay";
		this.playPauseBtn.innerHTML = "Play";
		this.playPauseBtn.onclick = () => { togglePlayPause(); }

		this.muteBtn = document.createElement("button");
		this.muteBtn.id = "MediaPlayerMute";
		this.muteBtn.innerHTML = "Mute";
		this.muteBtn.onclick = () => { toggleMute(); }
		
		this.progressBar = document.createElement("progress");
		this.progressBar.id = "MediaPlayerProgress";
		this.progressBar.innerHTML = "0 % played";
		this.progressBar.className = "slidePopupProgressbar";
		this.progressBar.style.position = "";
		this.progressBar.min = "0";
		this.progressBar.max = "100";
		this.progressBar.value = "0";
		this.progressBar.addEventListener("mousedown", eventProgressbarMouseDown);
		this.progressBar.addEventListener("mouseup", eventProgressbarMouseUp);
		//touchstart, touchmove ?

		this.volumeBar = document.createElement("progress");
		this.volumeBar.id = "MediaPlayerVolume";
		this.volumeBar.innerHTML = "0 % played";
		this.volumeBar.className = "slidePopupVolumebar";
		this.volumeBar.style.marginLeft = "10px";
		this.volumeBar.min = "0";
		this.volumeBar.max = "100";
		this.volumeBar.value = "100";
		this.volumeBar.height = "100";
		this.volumeBar.addEventListener("mousedown", eventVolumebarMouseDown);
		this.volumeBar.addEventListener("mouseup", eventVolumebarMouseUp);
		//touchstart, touchmove ?

		//hide interface by default
		this.show(false);
	}

	show(value) {
		if (value == true) {
			this.mainDiv.style.display = "block";
		} else {
			this.mainDiv.style.display = "none";
        }
	}

	attachPlayerToHtmlTagId(htmlTagId) {
		var newdiv = document.getElementById(htmlTagId).appendChild(this.mainDiv);
		newdiv.appendChild(this.heightHelper);
		newdiv.appendChild(this.titleDiv);
		newdiv.appendChild(this.closeButton);

		var narrationDiv = newdiv.appendChild(this.narrationDiv);
		narrationDiv.appendChild(this.narrationHtml);

		var contentDiv = newdiv.appendChild(this.contentDiv);
		contentDiv.appendChild(this.contentInsetShadow);
		contentDiv.appendChild(this.contentHtmlDiv);
		contentDiv.appendChild(this.contentImageDiv);
		contentDiv.appendChild(this.canvas);

		this.mediaPlayer.appendChild(this.audioSource);
		var controls = newdiv.appendChild(this.mediaPlayerControls);
		controls.appendChild(this.mediaPlayer);
		//controls.appendChild(this.reloadBtn);
		//controls.appendChild(this.playPauseBtn);
		//controls.appendChild(this.muteBtn);
		//controls.appendChild(this.progressBar);
		//controls.appendChild(this.volumeBar);
	}

	removePlayerFromHtmlTagId() {
		this.mainDiv.remove();
	}

	setAudioSource(srcFile) {
		this.audioSource.src = srcFile;
		//this.audioSource.load();
	}

	setNarration(html) {
		this.narrationHtml.innerHTML = html;
    }

	addNarrationError(html) {
		this.narrationHtml.innerHTML = html + this.narrationHtml.innerHTML
		//this.narrationHtml.scrollTop(0);
	}

	setContentHtml(html) {
		this.contentHtmlDiv.innerHTML = html;
	}

	setContentImage(imageSrc) {
		this.contentImageDiv.src = imageSrc;
	}

	hideContentImage() {
		this.contentInsetShadow.style.display = "none";
		this.contentImageDiv.style.display = "none";
	}

	showContentImage() {
		this.contentInsetShadow.style.display = "block";
		this.contentImageDiv.style.display = "block";
	}

	setTitle(html) {
		this.titleDiv.innerHTML = html;
	}

	play() {
		this.mediaPlayer.load();
		this.mediaPlayer.play();
	}

	pause() {
		this.mediaPlayer.pause();
	}

}


